#!/usr/bin/env python
#Usage: $0 uni0E01 > code.txt
#or:    $0 --all

import os
import sys
import dfont

# cvt value
#NEW VALUE ***
#    "headdia":          257,    #384
#    "headstem":         258,    #120
#    "w_896":            256,    #896    =ko_kai
cvt_dict = {
#    "w_1001":           71,     #1001   =
#
    "hstem":            16,     #354
#
    "vstem":            162,    #121    =straight vstem
    "vstem_113":        51,     #113    =curve vstem
#
    "headdia":          31,     #385
    "headhole":         181,    #170   
    "headstem":         9,      #106   
    "headstem_plus_hole":   8,  #272
    "headdia_small":    15,     #348
    "headstem_small":   159,    #98
    "headstem_small_plus_hole":   7,    #246
#
    "vheight":          156,    #1063   =normal height 
    "vheight_shoot":    158,    #1092   =overshoot height
    "vheight_po":       128,    #1556   =po_pla, fo_fa
#    "vheight_o":        179,    #1638   =sara_o, sara_i
    "vheight_lo":       112,    #29 
    "vheight_lu":       23,     #408    =lo_lu
#
    "vheight_below_do": 23,     #408
#
    "vheight_num":    0,    #905
    "special_1":      0,    #905
    "special_2":      0,    #905
    "w_852":      0,    #905
    "w_956":      0,    #905
    "headdia_tiny":      0,    #905
    "sarastem":      0,    #905
    "headstem_wan":      0,    #905
    "vstem_tiny":      0,    #905
    "gap_199":        56,
#    "vheight_sara1":    250,    #1262
#
    "gap_41":         84,     #41     =front/rear spacing
    "gap_61":         27,
    "gap_84":         50,
    "gap_102":        82,
    "gap_129":        52,
    "gap_152":        53,
    "gap_170":        181,
    "gap_190":        40,
    "gap_246":        7, 
    "gap_334":        98,
    "gap_395":        62,
    "gap_428":        37,
}

######### PSUEDO-CODE ##########
pseudo_code_dict = {
    #ko_kai
    "uni0E01": """
#NEW FUNCTION F_DELTAP, 
#DO NOT ENTER NUMBER OF PAIRS AND DEGREE OF DELTA
#JUST TYPE f_deltap NOT f_deltap1 OR deltap1
#FOLLOW BY tt_point_number AND ppem + OR - selector
#f_deltap    24 9+8 
# = MOVE point 24 TO +8 AT 9 ppem
f_deltap    24 9+8 
srp0            23
mirp[rp0,rnd,grey]  gap_170 13
mdrp[rp0,grey]  15
mdrp[min,grey]  8
srp0            13
mirp[rp0,min,rnd,grey]  hstem 11
mdrp[min,grey]  10
srp0            24
mirp[rp0,rnd,grey]  gap_170 21
mirp[rp0,min,rnd,grey]  hstem  1
IUP[x]
SVTCA[y-axis]
mdap[rnd]           1
alignrp             13
mirp[rp0,rnd,grey]  vheight_shoot 18
ip  14
mirp[min,rnd,grey]  vstem_113  5
mdap[rnd]   14
f_deltap    14 11-6
alignrp     10
mirp[min,rnd,grey]  vstem   8
IUP[y]
""",

    #kho_khai
    "uni0E02":  """
f_deltap    56 9+8  56 10+8     56 15-8     56 27+8
srp0                55
mirp[rp0,rnd,grey]  gap_334 3
ip  23
f_deltap    3 14+8  3 15+8 
mirp[min,rnd,grey]  hstem 34
mdrp[grey]  1
mdap[rnd]   23
mdrp[min,rnd,grey]  52
mdrp[rp0,rnd,grey]  17
f_deltap    17 18-8     17 19-8     17 20-8
mirp[min,rnd,grey]  headstem 46
srp0        23
mdrp[rp0,rnd,grey]  29
f_deltap    29 9+4      29 12+4     29 14+8     29 15+8     29 19-8     29 21-8
mdrp[min,rnd,grey]  9
#
srp0        56
mirp[rp0,rnd,white] gap_170 40
mirp[min,rnd,grey]  hstem 38
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]           0
mirp[min,rnd,grey]  vstem 36
shp[rp2]            3
mirp[rnd,grey]      vheight 40
mirp[rp0,rnd,grey]  vheight_shoot 26
mdrp[min,rnd,grey]  12
mdrp[rp0,rnd,grey]  14
mirp[min,rnd,grey]  headstem 49
mirp[rp0,rnd,grey]  headdia 20
f_deltap    20 13-8     20 14-8     20 15-8     20 16-8     20 26+8
mirp[min,rnd,grey]  headstem 43
IUP[y]
""",

    #kho_khuad
    "uni0E03": """
f_deltap    59 9+8 59 10+8 59 15-8 59 18-8 59 17+8 59 18+8 59 21+8
srp0        58
mirp[rp0,rnd,grey]  gap_395 3
ip  24
f_deltap    3 13+8 3 14+8 3 15+8 3 18+8 3 21+8 3 26+8
mdrp[grey]  1
mirp[min,rnd,grey]  hstem 37
mdap[rnd]   24
mdrp[min,grey]  13
mdrp[min,rnd,grey]  55
mdrp[rp0,rnd,grey]  18
f_deltap    18 12+8 18 18-8 18 21-8 18 20-8
mirp[min,rnd,grey]  headstem 49
srp0    24
mdrp[rp0,rnd,grey]  32
f_deltap    32 9+8 32 10+2 32 11+4 32 13+4 32 14+8 32 18+8 32 24-8 
sloop   6
ip      27 28 29 9 10 11
mdrp[min,rnd,grey]  9
#
srp0    59
mirp[rp0,rnd,grey]  gap_170 43
mirp[min,rnd,grey]  hstem 41
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]           0
mirp[min,rnd,grey]  vstem 39
shp[rp2]    3
mirp[rnd,grey]      vheight 43
mirp[rp0,rnd,grey]  vheight_shoot 27
alignrp     29
mdrp[min,rnd,grey]  13
shp[rp2]    11
mdrp[rp0,min,rnd,grey]  28
mdrp[rp0,min,rnd,grey]  12
mdrp[rp0,rnd,white]     15
mirp[min,rnd,grey]  headstem 52
mirp[rp0,rnd,grey]  headdia 21
f_deltap    21 9+8 21 10+8 21 11+8 21 18-8
mirp[min,rnd,grey]  headstem 46
IUP[y]

""",

    #kho_kwai
    "uni0E04": """
f_deltap    46 9+8    46 10+8   46 11+8   46 16-8   46 17-8   46 18+8    46 21+8   46 22+8   
srp0                45
mirp[rp0,rnd,white] gap_190 23
ip  26
mirp[min,rnd,grey]  hstem 21
ip  10
srp0    26
mdrp[min,rnd,grey]  8
#
srp0                46
mirp[rp0,rnd,white] gap_170 32
mirp[min,rnd,grey]  hstem 1
#
srp1    21
ip      16
mdap[rnd]  16
f_deltap    16 11+4
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 42
f_deltap    42 20+8
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]           0
ALIGNRP             22
MIRP[rp0,rnd,grey]  vheight_shoot  29
MIRP[rp0,min,rnd,grey]  vstem_113  5
srp1    0
ip  13
mdap[rnd]   13
f_deltap    13 16-8   13 20-8
MIRP[min,rnd,grey]  headstem  39
MIRP[rp0,rnd,grey]  headdia  19
f_deltap    19 13-8     19 14-8     19 15-8     19 16-8
MIRP[min,rnd,grey]  headstem  33
IUP[y]
""",

    #kho_kon
    "uni0E05": """
f_deltap    50 9+8   50 10+8   50 16-8   50 18+8   50 27+8
srp0                49
mirp[rp0,rnd,white] gap_170 25
ip  28
mirp[min,rnd,grey]  hstem 23
ip  12
srp0 28
mdrp[rp0,rnd,grey]  10
#
srp0                50
mirp[rp0,rnd,white] gap_170 36
mirp[min,rnd,grey]  hstem 1
srp1        23
sloop       7
ip          31 32 33 5 6 7 18
#
mdap[rnd]   18
f_deltap    18 11+4   18 20-8   
mirp[min,rnd,grey]  headstem 40
mirp[rnd,grey]  headstem_plus_hole 46
f_deltap    46 20+8
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]           0
ALIGNRP             24
MIRP[rp0,rnd,grey]  vheight_shoot  31
alignrp             33
MIRP[min,rnd,grey]  vstem_113  7
shp[rp2]        5
mdrp[rp0,min,rnd,grey]  32
mdrp[rp0,rnd,grey]  6
f_deltap    6 10+8   6 11+8   
MDRP[rp0,min,rnd,white]  15
MIRP[min,rnd,grey]  headstem  43
MIRP[rp0,rnd,grey]  headdia  21
f_deltap    21 13-8   21 14-8   21 15-8   21 16-8   
MIRP[min,rnd,grey]  headstem  37
IUP[y]
""",

    #kho_rakhang
    "uni0E06": """
f_deltap    80 9+8   80 21+8   80 27+8
srp0        79
mdrp[rp0,rnd,grey]  14
ip  33
ip  9
mirp[min,rnd,grey]  hstem 44
ip  3
mdap[rnd]    33
mdrp[min,rnd,grey]  24
mdrp[rp0,rnd,grey]  27
f_deltap    27 18-8   27 19-8
mirp[min,rnd,grey]  headstem 58
mirp[rnd,grey]  headstem_plus_hole 64
srp0    33
mdrp[rp0,rnd,grey]  41
f_deltap    41 9+6   41 12-8   41 14+8
sloop   6
ip      36 37 38 20 21 22
mdrp[min,rnd,grey]  18
mdap[rnd]   9
mirp[min,rnd,grey]  headstem 76
mirp[rnd,grey]  headstem_plus_hole 70
f_deltap    70 12+8
#
srp0        80
mirp[rp0,rnd,white] gap_170 52
mirp[min,rnd,grey]  hstem 50
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     6
mirp[min,rnd,grey]  vstem 48
mirp[rnd,grey]  vheight 52
mirp[rp0,rnd,grey]  vheight_shoot 36
alignrp     38
mdrp[min,rnd,grey]  22
shp[rp2]    20
mdrp[rp0,white]  37
mdrp[rp0,grey]  21
mdrp[rp0,rnd,white]  24
mirp[min,rnd,grey]  headstem 61
mirp[rp0,rnd,grey]  headdia 30
f_deltap    30 14-6   30 15-6   30 16-6   
mirp[min,rnd,grey]  headstem 55
srp0    6
mdrp[min,rnd,grey]  67
mdrp[rp0,rnd,grey]  12
ip      45
mirp[min,rnd,grey]  headstem 73
srp0    45
mdrp[min,rnd,grey]  3
IUP[y]
""",

    #ngo_ngu
    "uni0E07": """
f_deltap    35 9+8
srp0    34
mirp[rp0,rnd,grey]  gap_41 2
mdrp[grey]  3
#
srp0    35
mirp[rp0,rnd,white]  gap_170 19
mirp[min,rnd,grey]  hstem 7
srp1    3
ip      1
ip      5
mdrp[rp0,rnd,grey]  13
f_deltap    13 12+8   13 16+7
mirp[min,rnd,grey]  headstem 31
mirp[rnd,grey]  headstem_plus_hole 25
#
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 4
mirp[rp0,rnd,grey]  vheight 16
mdrp[min,rnd,grey]  28
mdrp[rp0,rnd,grey]  10
mirp[min,rnd,grey]  headstem 22
srp2    1
ip      3
ip      2
IUP[y]
""",

    #jo_jan
    "uni0E08": """
f_deltap    50 9+8   50 10+8   50 16-8   50 17-8   50 18+8   50 24-8
srp0    49
mirp[rp0,rnd,grey] gap_334 2
f_deltap    2 13+8   2 14+8   2 15+8   
ip  8
ip  27
mirp[min,rnd,grey]  hstem 14
mdap[rnd]   8
f_deltap    8 9+4   8 10+4   8 11+4   8 12+4
mirp[min,rnd,grey]  headstem 46
mirp[rnd,grey]  headstem_plus_hole 40
#
srp0    50
mirp[rp0,rnd,grey]  gap_170 34
mirp[min,rnd,grey]  hstem 19
IUP[x]
SVTCA[y-axis]
mdap[rnd]  0
mirp[min,rnd,grey]  vstem 17
mirp[rp0,rnd,grey]  vheight_shoot 31
ip  27
mirp[min,rnd,grey]  vstem_113 23
srp0    27
mdrp[rp0,rnd,white]   11
f_deltap    11 9-4   11 10-4   11 11+4   11 12+4   11 13+4   11 14-2
mirp[min,rnd,grey]  headstem 43
mirp[rp0,rnd,grey]  headdia 5
f_deltap    5 13-8   5 14-8   5 15-8   5 16-8
mirp[min,rnd,grey]  headstem 37
IUP[y]
""",

    #cho_ching
    "uni0E09": """
f_deltap    69 9+8   69 10+8   69 13+8   69 22+8   69 28+8
srp0    68
mirp[rp0,rnd,grey] gap_334 1
f_deltap    1 13+8   1 14+8   1 15+8
ip  7
ip  24
mirp[min,rnd,grey]  hstem 13
shp[rp2]    0
mdap[rnd]   7
f_deltap    7 9+4   7 10+4   7 11+4   7 12+4
mirp[min,rnd,grey]  headstem 53
mirp[rnd,grey]  headstem_plus_hole 47
#
srp0    69
mirp[rp0,rnd,grey]  gap_190 31
ip  36
mirp[min,rnd,grey]  hstem 16
shp[rp2]    42
mdap[rnd]   36
mirp[min,rnd,grey]  headstem 59
mirp[rnd,grey]  headstem_plus_hole 65
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     39
mdrp[min,rnd,grey]  14
mirp[rp0,rnd,grey]  vheight_shoot  28
ip  24
mirp[min,rnd,grey]  vstem_113 20
srp0    24
mdrp[rp0,rnd,white]  10
f_deltap    10 9-4   10 10-4   10 11-4   10 12-8   10 13+4   10 14-2
mirp[min,rnd,grey]  headstem 50
mirp[rp0,rnd,grey]  headdia 4
f_deltap    4 13-8   4 14-8   4 15-8   4 16-8
mirp[min,rnd,grey]  headstem 44
srp0    39
mdrp[min,rnd,grey]  59
mdrp[rp0,rnd,grey]  33
ip      16
ip      42
mirp[min,rnd,grey]  headstem 62
IUP[y]
""",

    #cho_chang
    "uni0E0A": """
f_deltap    70 10+8   
srp0    69
mirp[rp0,rnd,grey]  gap_334 3
ip  23
f_deltap    3 13+8   3 14+8   3 15+8
mdrp[grey]  1
mirp[min,rnd,grey]  hstem 55
mdap[rnd]   23
mdrp[min,rnd,grey]  66
mdrp[rp0,rnd,grey]  17
f_deltap    17 20-8
mirp[min,rnd,grey]  headstem 60
srp0    23
mdrp[rp0,rnd,grey]  29
f_deltap    29 14+8   29 15+8
alignrp 50
mdrp[min,rnd,grey]  9
mdrp[grey]  36
#
srp0    70
mirp[rp0,rnd,grey]  gap_170 39
ip  33
mirp[min,rnd,grey]  hstem 46
ip  32
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 43
shp[rp2]    3
mirp[rp0,rnd,grey]      vheight_shoot 26
sloop   3
ip      29 36 50
mdrp[rnd,grey]  32
mdrp[rp0,min,rnd,grey]  12
mdrp[rp0,rnd,white]     14
mirp[min,rnd,grey]      headstem 63
mirp[rp0,rnd,grey]      headdia 20
f_deltap    20 13-8   20 14-8   20 15-8   20 16-8
mirp[min,rnd,grey]      headstem 57
IUP[y]
""",

    #so_zo
    "uni0E0B": """
f_deltap    73 9+8 73 10+8 73 15-8 73 18-8 73 17+8 73 18+8 73 21+8
srp0        72
mirp[rp0,rnd,grey]  gap_395 3
ip  24
f_deltap    3 13+8  3 14+8  3 15+8  3 16+8  3 17+8   3 18+8  3 19+8   3 24+8  3 26+8
mdrp[grey]  1
mirp[min,rnd,grey]  hstem 58
mdap[rnd]   24
mdrp[min,grey]  15
mdrp[min,rnd,grey]  69
mdrp[rp0,rnd,grey]  18
f_deltap    18 12+8 18 18-8 18 21-8 18 20-8
mirp[min,rnd,grey]  headstem 63
srp0    24
mdrp[rp0,rnd,grey]  32
f_deltap    32 9+8 32 10+2 32 11+4 32 13+4 32 14+8  32 16+8  32 20-8  32 22-8  
alignrp 53
sloop   6
ip      27 28 29 11 12 13
mdrp[min,rnd,grey]  9
mdrp[grey]  39
#
srp0    73
mirp[rp0,rnd,grey]  gap_170 42
ip  36
mirp[min,rnd,grey]  hstem 49
ip  35
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]           0
mirp[min,rnd,grey]  vstem 46
shp[rp2]    3
mirp[rp0,rnd,grey]  vheight_shoot 27
alignrp     29
sloop   3
ip      32 39 53
mdrp[rnd,grey]  35
mdrp[min,rnd,grey]  13
shp[rp2]    11
mdrp[rp0,min,rnd,grey]  28
mdrp[rp0,min,rnd,grey]  12
mdrp[rp0,rnd,white]     15
mirp[min,rnd,grey]  headstem 66
mirp[rp0,rnd,grey]  headdia 21
f_deltap    21 9+8   21 10+8   21 11+8   21 14-8   21 15-8   21 16-8   21 21+8
mirp[min,rnd,grey]  headstem 60
IUP[y]
""",

    #cho_choe
    "uni0E0C": """
f_deltap    79 9+8   79 10+8
srp0    78
mirp[rp0,rnd,grey] gap_152 35
ip  37
mirp[min,rnd,grey]  hstem 23
mdrp[rp0,rnd,grey]  29
mirp[min,rnd,grey]  headstem 57
mirp[rnd,grey]  headstem_plus_hole 63
srp0    37
mdrp[min,rnd,grey]  20
#
srp0    79
mirp[rp0,rnd,grey]  gap_170 51
mirp[min,rnd,grey]  hstem 49
srp1    35
ip  13
mdap[rnd]   13
mirp[min,rnd,grey]  hstem 43
shp[rp2]    3
srp1    49
ip  1
ip  46
srp1    29
ip  9
mdap[rnd]   9
f_deltap    9 13+4  9 14+8  9 15+8  9 16+8  
mirp[min,rnd,grey]  headstem 75
mirp[rnd,grey]  headstem_plus_hole 69
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]  0
alignrp 6
alignrp 32
mirp[rnd,grey]  vheight 51
mirp[min,rnd,grey]  vstem 47
mirp[rp0,rnd,grey]  vheight_shoot 40
ip  36
mirp[min,rnd,grey]  vstem_113 17
srp0    6
mdrp[rp0,rnd,grey]  12
alignrp 26
ip  44
ip  3
mirp[min,rnd,grey]  headstem 72
shp[rp2]    60
mirp[rnd,grey]  headstem_plus_hole 66
shp[rp2]    54
mdap[rnd]   36
alignrp 23
mirp[min,rnd,grey]  vstem 20
IUP[y]
""",

    #yo_ying
    "uni0E0D": """
f_deltap    89 9+8  89 10+8  89 19+8  89 22+8  89 27+8
srp0    88
mirp[rp0,rnd,grey]  gap_170 24
ip  26
mirp[min,rnd,grey]  hstem 12
mdrp[rp0,rnd,grey]  18
mirp[min,rnd,grey]  headstem 45
mirp[rnd,grey]  headstem_plus_hole 51
srp0    26
mdrp[min,rnd,grey]  9
#
srp0    89
mirp[rp0,rnd,grey]  gap_170 39
mirp[min,rnd,grey]  hstem 37
srp1    24
ip  2
mdap[rnd]   2
mirp[min,rnd,grey]  hstem 32
#
srp2    41
ip  57
ip  73
mdap[rnd]   57
f_deltap    57 13-8   57 14-8  57 15-8  57 16-8
mdrp[min,rnd,grey]  67
mdrp[min,rnd,grey]  85
mdrp[rp0,rnd,grey]  63
mdrp[min,rnd,grey]  79
mdap[rnd]   73
mdrp[min,rnd,grey]  72
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     21
mirp[min,rnd,grey]  vstem 35
mirp[rnd,grey]  vheight 39
mirp[rp0,rnd,grey]  vheight_shoot 29
ip          25
mirp[min,rnd,grey]  vstem_113 6
srp0        21
mdrp[rp0,rnd,grey] 15
mirp[min,rnd,grey] headstem 48
mirp[rnd,grey] headstem_plus_hole 42
mdap[rnd]   25
alignrp     12
mdrp[min,rnd,grey]  9
srp0        0
mdrp[rp0,rnd,white] 60
alignrp     76
mdrp[min,rnd,grey]  82
ip  73
mdrp[rp0,rnd,grey]  67
mdrp[min,rnd,grey]  76
srp0    60
mdrp[rp0,rnd,grey]  54
mdrp[min,rnd,grey]  69
IUP[y]
""",

    #yo_ying
    "uni0E0D.descless": """
f_deltap    55 9+8  55 10+8  55 19+8  55 22+8  55 27+8
srp0    54
mirp[rp0,rnd,grey]  gap_170 24
ip  26
mirp[min,rnd,grey]  hstem 12
mdrp[rp0,rnd,grey]  18
mirp[min,rnd,grey]  headstem 45
mirp[rnd,grey]  headstem_plus_hole 51
srp0    26
mdrp[min,rnd,grey]  9
#
srp0    55
mirp[rp0,rnd,grey]  gap_170 39
mirp[min,rnd,grey]  hstem 37
srp1    24
ip  2
mdap[rnd]   2
mirp[min,rnd,grey]  hstem 32
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     21
mirp[min,rnd,grey]  vstem 35
mirp[rnd,grey]  vheight 39
mirp[rp0,rnd,grey]  vheight_shoot 29
ip          25
mirp[min,rnd,grey]  vstem_113 6
srp0        21
mdrp[rp0,rnd,grey] 15
mirp[min,rnd,grey] headstem 48
mirp[rnd,grey] headstem_plus_hole 42
mdap[rnd]   25
alignrp     12
mdrp[min,rnd,grey]  9
IUP[y]
""",

    #do_chada
    "uni0E0E": """
f_deltap    83 10+8
srp0    82
mirp[rp0,rnd,grey]  gap_334 47
ip  42
ip  49
mirp[min,rnd,grey]  hstem 35
mdap[rnd]   42
mirp[min,rnd,grey]  headstem 67
mirp[rnd,grey]  headstem_plus_hole 61
srp0    49
mdrp[min,rnd,grey]  32
ip  9
mdap[rnd]   9
mdrp[min,rnd,grey]  79
#
srp0    83
mirp[rp0,rnd,grey]  gap_170 55
mirp[min,rnd,grey]  hstem 25
srp1    79
sloop   8
ip  73 15 17 18 20 22 1 3
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   39
mirp[rp0,rnd,grey]  vheight_shoot 52
ip  48
mirp[min,rnd,grey]  vstem_113   29
mdap[rnd]   48
alignrp 35
mirp[min,rnd,grey]  vstem 32
srp0    39
mdrp[rp0,rnd,grey]  45
mirp[min,rnd,grey]  headstem 64
mirp[rnd,grey]  headstem_plus_hole 58
srp0    39
mdrp[rp0,min,rnd,white] 12
mirp[min,rnd,grey]  headstem   76
mdrp[rp0,rnd,grey]  6
sloop   6
ip  15 17 18 20 73 3
shp[rp2]    0
mirp[min,rnd,grey]  headstem   70
shp[rp2]    22
f_deltap    12 13+6   76 13+6
IUP[y]
""",

    #to_patak
    "uni0E0F": """
f_deltap    89 10+8
srp0    88
mirp[rp0,rnd,grey]  gap_334 53
ip  48
ip  55
ip  12
mirp[min,rnd,grey]  hstem 41
mdap[rnd]   48
mirp[min,rnd,grey]  headstem 73
mirp[rnd,grey]  headstem_plus_hole 67
srp0    55
mdrp[min,rnd,grey]  38
mdap[rnd]   12
mdrp[min,rnd,grey]  85
#
srp0    89
mirp[rp0,rnd,grey]  gap_170 61
mirp[min,rnd,grey]  hstem 31
srp1    86
sloop   14
ip  79 18 20 21 23 25 26 27 28 1 2 3 4 6
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   45
mirp[rp0,rnd,grey]  vheight_shoot 58
ip  54
mirp[min,rnd,grey]  vstem_113   35
mdap[rnd]   54
alignrp 41
mirp[min,rnd,grey]  vstem 38
srp0    45
mdrp[rp0,rnd,grey]  51
mirp[min,rnd,grey]  headstem 70
mirp[rnd,grey]  headstem_plus_hole 64
srp0    45
mdrp[rp0,min,rnd,white] 15
mirp[min,rnd,grey]  headstem   76
mdrp[rp0,min,rnd,grey]  9
sloop   6
ip  79 18 20 21 23 26
shp[rp2]    3
shp[rp2]    0
mirp[min,rnd,grey]  headstem   76
sloop   4
shp[rp2]    6 25 2 28
f_deltap    15 13+6   82 13+6
IUP[y]
""",

    #tho_than
    "uni0E10": """
f_deltap    122 9+8   122 10+8   122 18+8   122 21+8   122 28+8
srp0        121
mirp[rp0,rnd,grey]  gap_334 2
ip  8
ip  21
mirp[min,rnd,grey]  hstem 14
mdap[rnd]   8
f_deltap    8 9+4   8 10+4   8 11+4   8 12+4
mirp[min,rnd,grey]  headstem  51
mirp[rnd,grey]  headstem_plus_hole 45
srp0    21
mdrp[rp0,rnd,grey]  38
#
srp0        122
mirp[rp0,rnd,white] gap_170 39
ip  30
ip  29
alignrp     106
mirp[min,rnd,grey]  hstem 19
#
srp0        106
mdrp[min,rnd,grey]  94
mdrp[rp0,rnd,grey]  100
mdrp[min,rnd,grey]  118
mdrp[rnd,grey] 112
srp0        110
mdrp[rp0,rnd,grey]  75
mdrp[min,rnd,grey]  60
srp1        94
sloop       12
ip  56 80 82 83 85 87 91 63 65 67 68 70 
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 17
mirp[rp0,rnd,grey]  vheight_shoot   24
ip  21
alignrp     29
mirp[min,rnd,grey]  vstem_113 35
mdrp[rp0,rnd,grey]  27
mirp[min,rnd,grey]  vstem_113 32
srp0    21
mdrp[grey]      38
mdrp[grey]      20
srp0    38
mdrp[grey]      39
srp1    21
srp2    0
ip      11
mdap[rnd]   11
f_deltap    11 16-8   11 17-8
mdrp[rp0,rnd,grey]  5
mirp[min,rnd,grey]  headstem 42
mirp[rnd,grey]  headstem_plus_hole 48
f_deltap    11 18-8   11 19-8
srp0    0
mdrp[rp0,min,rnd,white]  103
mdrp[min,rnd,grey]  115
mdrp[rp0,rnd,grey]  97
mdrp[min,rnd,grey]  109
srp0    103
mdrp[rp0,rnd,grey]  62
alignrp 67
alignrp 72
mdrp[min,rnd,grey]  92
shp[rp2]    87
srp0    72
mdrp[min,rnd,grey]  54
mdrp[rp0,rnd,grey]  78
sloop   7
ip  56 80 81 83 85 89 70
mdrp[min,rnd,grey]  58
IUP[y]
""",

    #tho_than_descless
    "uni0E10.descless": """
f_deltap    55 9+8   55 10+8   55 18+8   55 21+8   55 28+8
srp0        54
mirp[rp0,rnd,grey]  gap_334 2
ip  8
ip  21
mirp[min,rnd,grey]  hstem 14
mdap[rnd]   8
f_deltap    8 9+4   8 10+4   8 11+4   8 12+4
mirp[min,rnd,grey]  headstem  51
mirp[rnd,grey]  headstem_plus_hole 45
srp0    21
mdrp[rp0,rnd,grey]  38
#
srp0        55
mirp[rp0,rnd,white] gap_170 39
ip  30
ip  29
mirp[min,rnd,grey]  hstem 19
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 17
mirp[rp0,rnd,grey]  vheight_shoot   24
ip  21
alignrp     29
mirp[min,rnd,grey]  vstem_113 35
mdrp[rp0,rnd,grey]  27
mirp[min,rnd,grey]  vstem_113 32
srp0    21
mdrp[grey]      38
mdrp[grey]      20
srp0    38
mdrp[grey]      39
srp1    21
srp2    0
ip      11
mdap[rnd]   11
f_deltap    11 16-8   11 17-8
mdrp[rp0,rnd,grey]  5
mirp[min,rnd,grey]  headstem 42
mirp[rnd,grey]  headstem_plus_hole 48
f_deltap    11 18-8   11 19-8
IUP[y]
""",

    #tho_nangmontho
    "uni0E11": """
f_deltap    70 9+8  70 12+8
srp0    69
mirp[rp0,rnd,grey]  gap_395 11
ip  32
f_deltap    11 13+8  11 14+8  11 15+8  11 16+8  11 17+8  11 18+8  11 19+8  11 20+8
mirp[min,rnd,grey]  hstem 45
shp[rp2]    10
mdap[rnd]   32
mdrp[min,rnd,grey]  23
mdrp[min,rnd,grey]  66
mdrp[rp0,rnd,grey]  26
mirp[min,rnd,grey]  headstem 60
srp0    32
mdrp[rp0,rnd,grey]  40
f_deltap    40 14+4
sloop   6
ip  35 36 37 19 20 21
mdrp[min,rnd,grey]  17
#
srp0    70
mirp[rp0,rnd,white] gap_170 56
mirp[min,rnd,grey]  hstem 1
srp1    40
ip  50
ip  6
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   10
alignrp 1
mdrp[min,rnd,grey]  46
mirp[rp0,rnd,grey]  vheight 53
mdrp[min,rnd,grey]  4
srp0    10
mirp[rp0,rnd,grey]  vheight_shoot  35
alignrp 37
srp0    35
mdrp[min,rnd,grey]  21
shp[rp2]    19
mdrp[rp0,min,rnd,grey]  36
f_deltap    36 9+4   36 10+4   36 11+4   36 13+4
mdrp[rp0,min,rnd,grey]  20
f_deltap    20 9+4   20 10+4   20 11+4   20 13+4
mdrp[rp0,rnd,white]  23
mirp[min,rnd,grey]  headstem    63
mirp[rp0,rnd,grey]  headdia 29
f_deltap    29 13-8  29 14-8  29 15-8  29 16-8
mirp[min,rnd,grey]  headstem 57
IUP[y]
""",

    #tho_phuthao
    "uni0E12": """
f_deltap    97 9+8   97 10+8   97 11+8
SRP0                96
mirp[rp0,rnd,grey]  gap_170 47
ip  53
mirp[min,rnd,grey]  hstem 45
srp0    53
mdrp[min,rnd,grey]  22
#
srp0    97
f_deltap    97 9+8
mirp[rp0,rnd,grey]  gap_170 69
mirp[min,rnd,grey]  hstem 67
srp1    47
ip      13
mdap[rnd]   13
f_deltap    13 13+8
srp2    22
sloop   6
ip      56 57 58 17 18 19
srp2    45
ip      40
ip      9
mirp[min,rnd,grey]  hstem 61
srp1    67
ip      64
ip      1
mdap[rnd]   9
mirp[min,rnd,grey]  headstem 93
mirp[rnd,grey]  headstem_plus_hole 87
mdap[rnd]   40
f_deltap    40 9-8   40 10-4   
mdrp[min,rnd,grey]  31
mirp[min,rnd,grey]  headstem 75
mirp[rp0,rnd,grey]  headdia 34
f_deltap    34 13-8   34 14-8   34 15-8   34 16-8
mirp[min,rnd,grey]  headstem 81
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
ALIGNRP     6
ALIGNRP     46
mirp[min,rnd,grey]      vstem 65
mirp[rnd,grey]          vheight 69
MIRP[rp0,rnd,grey]      vheight_shoot  56
alignrp     58
MIRP[min,rnd,grey]      vstem  19
shp[rp2]    17
mdrp[rp0,white]     57
mdrp[rp0,rnd,grey]      18
mdrp[rp0,rnd,white]     37
f_deltap    37 13-3   37 14-3   37 15-3
mirp[min,rnd,grey]      headstem 78
mirp[rp0,rnd,grey]      headdia 31
f_deltap    31 13-8   31 14-8   31 15-8   31 16-8
mirp[min,rnd,grey]      headstem 72
srp2        46
ip          28
srp0        6
mdrp[rp0,rnd,grey]  12
ip      62
ip      3
mirp[min,rnd,grey]  headstem 90
mirp[rnd,grey]  headstem_plus_hole 84
IUP[y]
""",

    #no_nane
    "uni0E13": """
f_deltap    74 9+8  74 10+8  74 12+8  74 13+8   74 19+8   74 22+8   74 27+8   74 39+8
srp0    73
mirp[rp0,rnd,grey]  gap_170 23
ip  25
mirp[min,rnd,grey]  hstem 11
mdrp[rp0,rnd,grey]  17
f_deltap    17 9-4
mirp[min,rnd,grey]  headstem 52
mirp[rnd,grey]  headstem_plus_hole 58
srp0    25
mdrp[min,rnd,grey]  8
#
srp0    74
mirp[rp0,rnd,grey]  gap_190 36
ip  41
mirp[min,rnd,grey]  hstem 34
shp[rp2]    47
srp1    23
ip  1
mdap[rnd]   1
mirp[min,rnd,grey]  hstem 31
shp[rp2]    0
mdap[rnd]   41
f_deltap    41 9-4
mirp[min,rnd,grey]  headstem 64
mirp[rnd,grey]  headstem_plus_hole 70
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     20
alignrp     44
mdrp[min,rnd,grey]  32
mirp[rnd,grey]  vheight 36
mirp[rp0,rnd,grey]  vheight_shoot 28
ip  24
mirp[min,rnd,grey]  vstem_113 5
mdap[rnd]   24
alignrp     11
mirp[min,rnd,grey] vstem 8
srp0    20
mdrp[rp0,rnd,grey]  14
alignrp 38
ip  34
ip  47
mirp[min,rnd,grey] headstem 55
shp[rp2]    67
mirp[rnd,grey] headstem_plus_hole 49
shp[rp2]    61
IUP[y]
""",

    #do_dek
    "uni0E14": """
f_deltap    59 9+8  59 10+8  59 11+8  59 27+8
SRP0        58
MIRP[rp0,rnd,grey]  gap_170 33
ip  39
mirp[min,rnd,grey]  hstem 31
ip      14
srp0    39
mdrp[min,rnd,grey]  8
#
srp0    59
mirp[rp0,rnd,grey]  gap_170 45
mirp[min,rnd,grey]  hstem 1
srp1    31
ip  26
mdap[rnd]   26
f_deltap    26 9-4  26 10-4   26 16-8   26 17-8
mirp[min,rnd,grey]  headstem 49
mirp[rp0,rnd,grey]  headdia 20
f_deltap    20 13-8   20 14-8   20 15-8   20 16-8
mirp[min,rnd,grey]  headstem 55
f_deltap    29 15+8   29 16+8   29 17+8
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]           1
ALIGNRP             32
MIRP[rp0,rnd,grey]  vheight_shoot  42
MIRP[min,rnd,grey]  vstem_113  5
mdrp[rp0,rnd,grey]  23
f_deltap    23 16-8   23 17-8
mirp[min,rnd,grey]  headstem 52
mirp[rp0,rnd,grey]  headdia 17
f_deltap    17 13-8   17 14-8   17 15-8   17 16-8
mirp[min,rnd,grey]  headstem 46
srp2                32
ip                  14
IUP[y]
""",

    #to_tao
    "uni0E15": """
f_deltap    63 9+8  63 10+8  63 11+8  63 27+8
SRP0        62
MIRP[rp0,rnd,grey]  gap_170 35
ip  41
mirp[min,rnd,grey]  hstem 33
ip      16
srp0    41
mdrp[min,rnd,grey]  10
#
srp0    63
mirp[rp0,rnd,grey]  gap_170 49
mirp[min,rnd,grey]  hstem 1
srp1    33
ip  28
mdap[rnd]   28
f_deltap    28 9-4  28 10-4   28 16-8   28 19-8
mirp[min,rnd,grey]  headstem 53
mirp[rp0,rnd,grey]  headdia 22
f_deltap    22 13-8   22 14-8   22 15-8   22 16-8
mirp[min,rnd,grey]  headstem 59
f_deltap    31 15+8   31 16+8   31 17+8
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]           1
ALIGNRP             34
MIRP[rp0,rnd,grey]  vheight_shoot  44
alignrp     46
MIRP[min,rnd,grey]  vstem_113  7
shp[rp2]    5
mdrp[rp0,rnd,grey]  45
mdrp[rp0,min,rnd,grey]  6
mdrp[rp0,min,rnd,grey]  25
#f_deltap    25 16-8   25 19-8
mirp[min,rnd,grey]  headstem 56
mirp[rp0,rnd,grey]  headdia 19
f_deltap    19 13-8   19 14-8   19 15-8   19 16-8
mirp[min,rnd,grey]  headstem 50
srp2                34
ip                  16
IUP[y]
""",

    #to_tung
    "uni0E16": """
f_deltap    46 9+8   46 10+8   46 12+8   46 19+8   46 27+8
srp0                45
mirp[rp0,rnd,grey]  gap_170 23
ip  25
mirp[min,rnd,grey]  hstem 11
mdrp[rp0,rnd,grey]  17
f_deltap    17 9-4   17 12-4   17 16-8   17 19-8   17 26-8   17 33-8
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 42
srp0    25
mdrp[min,rnd,grey]  8
#
srp0                46
mirp[rp0,rnd,white] gap_170 31
mirp[min,rnd,grey]  hstem   1
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]           1
alignrp             20
mirp[rp0,rnd,grey]  vheight_shoot    28
ip  24
mirp[min,rnd,grey]  vstem_113  5
mdap[rnd]   24
alignrp     11
mirp[min,rnd,grey]  vstem   8
srp0        20
mdrp[rp0,rnd,grey]  14
f_deltap    14 18-8   14 19-8   14 23-8   14 24-8   14 25-8   14 26-8   14 28-8
mirp[min,rnd,grey]  headstem 39
mirp[rnd,grey]  headstem_plus_hole 33
IUP[y]
""",

    #tho_thahan
    "uni0E17": """
f_deltap    44 9+8   44 10+8   44 11+8   44 19+8    44 28+8
srp0        43
mirp[rp0,rnd,grey]  gap_334 10
ip  16
mirp[min,rnd,grey]  hstem 22
shp[rp2]    9
mdap[rnd]   16
f_deltap    16 10+4   16 11+4   16 12+4
mirp[min,rnd,grey]  headstem 40
mirp[rnd,grey]  headstem_plus_hole 34
#
srp0        44
mirp[rp0,rnd,white] gap_170 30
mirp[min,rnd,grey]  hstem 1
srp1        22
ip  24
ip  8
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     9
mirp[rp0,rnd,grey]  vheight 27
alignrp     19
ip  23
mdrp[min,rnd,grey]  5
srp0        19
mdrp[rp0,rnd,grey]  13
f_deltap    13 18+8   13 19+8   13 23+8   13 24+8   13 25+8   13 26+8   
mirp[min,rnd,grey]  headstem 31
mirp[rnd,grey]  headstem_plus_hole 37
IUP[y]
""",

    #to_thong
    "uni0E18": """
f_deltap    44 9+8   44 10+8   44 11+8   44 12+8
srp0        43
mirp[rp0,rnd,grey] gap_334 3
alignrp     39
ip  5
mdrp[grey]  1
mirp[min,rnd,grey]  hstem 37
shp[rp2]    28
ip      27
srp0        5
mdrp[min,rnd,grey]  42
#
srp0    44
mirp[rp0,rnd,grey] gap_170 30
ip  16
ip  17
mirp[min,rnd,grey]  hstem 35
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 33
shp[rp2]    3
mirp[rp0,rnd,grey]  vheight_shoot 8
alignrp     16
mirp[min,rnd,grey]  vstem_113 25
mdrp[rp0,rnd,grey]  13
f_deltap    13 10+4   13 11+4
mirp[min,rnd,grey]  vstem 20
srp1    8
sloop   4
ip  10 11 22 23
srp0    4
mdrp[grey]  39
srp0    37
mdrp[grey]  29
mdrp[rnd,grey]  28
f_deltap    36 9-2   36 10-2   36 11-2   36 12-2   36 13-2   36 14-2  36 15-2  36 16-2
IUP[y]
""",

    #no_nu
    "uni0E19": """
srp0    55
mirp[rp0,rnd,grey]  gap_334  1
ip      7
mirp[min,rnd,grey]  hstem 13
shp[rp2]    0
mdap[rnd]   7
f_deltap    7 10+4   7 11+4   7 12+4
mirp[min,rnd,grey]  headstem 40
mirp[rnd,grey]  headstem_plus_hole 34
#
srp0    56
mirp[rp0,rnd,white]  gap_246 18
ip      23
mirp[min,rnd,grey]  hstem 16
shp[rp2]    29
mdap[rnd]   23
mirp[min,rnd,grey]  headstem 46
mirp[rnd,grey]  headstem_plus_hole 52
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     26
mdrp[min,rnd,grey]  14
mirp[rp0,rnd,grey]  vheight 10
alignrp     18
mdrp[rp0,rnd,grey]  4
f_deltap    4 18+8   4 19+8   4 23+8   4 24+8   4 25+8   4 26+8   4 28+8
mirp[min,rnd,grey]  headstem 31
mirp[rnd,grey]  headstem_plus_hole 37
srp0    26
mdrp[rp0,rnd,grey]  20
ip  16
ip  29
mirp[min,rnd,grey]  headstem 49
mirp[min,rnd,grey]  headstem_plus_hole 43
IUP[y]
""",

    #bo_baimai
    "uni0E1A": """
f_deltap    37 10+8    37 11+8   37 18+8   37 22+8   37 27+8   37 28+8   37 38+8   37 39+8
srp0    36
mirp[rp0,rnd,grey]  gap_334 3
ip      9
mdrp[grey]      1 
mirp[rp0,min,rnd,grey]  hstem 15
mdap[rnd]   9
f_deltap    9 10+4   9 11+4   9 12+4
mirp[min,rnd,grey]  headstem 33
mirp[rnd,grey]  headstem_plus_hole 27
#
srp0    37
mirp[rp0,rnd,grey]  gap_170 21
mirp[min,rnd,grey]  hstem 19
IUP[x]
SVTCA[y-axis]
mdap[rnd]  0
mirp[min,rnd,grey]  vstem 17
shp[rp2]    3
mirp[rp0,rnd,grey]  vheight 12
alignrp 21
mdrp[rp0,rnd,grey]  6
f_deltap    6 18+8   6 19+8   6 23+8   6 24+8   6 25+8   6 26+8   6 28+8
mirp[min,rnd,grey]  headstem 24
mirp[rnd,grey]  headstem_plus_hole 30
IUP[y]
""",

    #po_pla
    "uni0E1B": """
f_deltap    37 10+8    37 11+8   37 18+8   37 22+8   37 27+8   37 28+8    37 38+8   37 39+8
srp0    36
mirp[rp0,rnd,grey]  gap_334 3
ip      9
mdrp[grey]      1
mirp[rp0,min,rnd,grey]  hstem 15
mdap[rnd]   9
f_deltap    9 10+4   9 11+4   9 12+4
mirp[min,rnd,grey]  headstem 33
mirp[rnd,grey]  headstem_plus_hole 27
#
srp0    37
mirp[rp0,rnd,grey]  gap_170 21
mirp[min,rnd,grey]  hstem 19
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]  0
mirp[min,rnd,grey]  vstem 17
shp[rp2]    3
mirp[rnd,grey]  vheight_po  21
mirp[rp0,rnd,grey]  vheight 12
mdrp[rp0,rnd,grey]  6
f_deltap    6 18+8   6 19+8   6 23+8   6 24+8   6 25+8   6 26+8   6 28+8
mirp[min,rnd,grey]  headstem 24
mirp[rnd,grey]  headstem_plus_hole 30
IUP[y]
""",

    #po_pung
    "uni0E1C": """
f_deltap    38 10+8   38 11+8   38 18+8   38 27+8   38 28+8   39 28+8   41 28+8
srp0    37
mirp[rp0,rnd,grey]  gap_152 6
mirp[min,rnd,grey]  hstem 18
shp[rp2]    4
mdrp[rp0,rnd,grey]  13
f_deltap    13 12-4   13 16-8   
mirp[min,rnd,grey]  headstem 28
mirp[rnd,grey]  headstem_plus_hole 34
#
srp0    38
mdrp[rp0,rnd,grey] 23
mirp[min,rnd,grey]  hstem   21
shp[rp2]    1
srp1    18
ip  20
ip  3
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     5
mirp[rp0,rnd,grey]  vheight 10
alignrp 23
sloop   6
ip  19 20 21 2 3 4
mdrp[rp0,rnd,grey]  16
mirp[min,rnd,grey]  headstem 25
mirp[rnd,grey]  headstem_plus_hole 31
IUP[y]
""",

    #fo_fa
    "uni0E1D": """
f_deltap    38 10+8   38 11+8   38 18+8   38 27+8   38 28+8   39 28+8  41 28+8
srp0    37
mirp[rp0,rnd,grey]  gap_152 6
mirp[min,rnd,grey]  hstem 18
shp[rp2]    4
mdrp[rp0,rnd,grey]  13
f_deltap    13 12-4   13 16-8   
mirp[min,rnd,grey]  headstem 28
mirp[rnd,grey]  headstem_plus_hole 34
#
srp0    38
mdrp[rp0,rnd,grey] 23
mirp[min,rnd,grey]  hstem   21
shp[rp2]    1
srp1    18
ip  20
ip  3
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     5
mirp[rnd,grey]  vheight_po 23
mirp[rp0,rnd,grey]  vheight 10
sloop   6
ip  19 20 21 2 3 4
mdrp[rp0,rnd,grey]  16
mirp[min,rnd,grey]  headstem 25
mirp[rnd,grey]  headstem_plus_hole 31
IUP[y]
""",

    #po_pan
    "uni0E1E": """
f_deltap   36 9+8   36 10+8   36 11+8   36 18+8   36 22+8   36 28+8   36 29+8    36 34+8   36 40+8   36 41+8   
srp0    35
mirp[rp0,rnd,grey]  gap_334  4
ip      10
mirp[min,rnd,grey]  hstem 16
shp[rp2]    3
mdap[rnd]   10
f_deltap    10 10+4   10 11+4    10 12+4   
mirp[min,rnd,grey]  headstem 32
mirp[rnd,grey]  headstem_plus_hole 26
#
srp0    36
f_deltap    36 10+8 
mirp[rp0,rnd,grey]  gap_170 22
mirp[min,rnd,grey]  hstem   20
shp[rp2]    1
srp1    16
sloop   3
ip      18 19 2
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     3
mdrp[min,rnd,grey]  20
shp[rp2]    17
mirp[rp0,rnd,grey]  vheight 13
alignrp 19
alignrp 22
ip  2
mdrp[rp0,rnd,grey]  7
f_deltap    7 18+8   7 19+8   7 23+8   7 24+8   7 25+8   7 26+8   7 28+8
mirp[min,rnd,grey]  headstem 23
mirp[rnd,grey]  headstem_plus_hole 29
IUP[y]
""",

    #fo_fan
    "uni0E1F": """
f_deltap   36 9+8   36 10+8   36 11+8   36 18+8   36 22+8   36 28+8   36 29+8    36 34+8   36 40+8   36 41+8
srp0    35
mirp[rp0,rnd,grey]  gap_334  4
ip      10
mirp[min,rnd,grey]  hstem 16
shp[rp2]    3
mdap[rnd]   10
f_deltap    10 10+4   10 11+4    10 12+4
mirp[min,rnd,grey]  headstem 32
mirp[rnd,grey]  headstem_plus_hole 26
#
srp0    36
f_deltap    36 10+8
mirp[rp0,rnd,grey]  gap_170 22
mirp[min,rnd,grey]  hstem   20
shp[rp2]    1
srp1    16
sloop   3
ip      18 19 2
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     3
mdrp[min,rnd,grey]  20
shp[rp2]    17
mirp[rnd,grey]  vheight_po  22
mirp[rp0,rnd,grey]  vheight 13
alignrp 19
ip  2
mdrp[rp0,rnd,grey]  7
f_deltap    7 18+8   7 19+8   7 23+8   7 24+8   7 25+8   7 26+8   7 28+8
mirp[min,rnd,grey]  headstem 23
mirp[rnd,grey]  headstem_plus_hole 29
IUP[y]
""",

    #po_sampao
    "uni0E20": """
f_deltap    46 10+8   46 18+8   46 28+8   46 29+8
srp0    45
mirp[rp0,rnd,grey]  gap_334 23
ip  18
ip  25
mirp[rp0,min,rnd,grey]  hstem 11
mdap[rnd]   18
f_deltap    18 10+4   18 11+4    18 12+4
mirp[min,rnd,grey]  headstem 42
mirp[rnd,grey]  headstem_plus_hole 36
srp0    25
mdrp[min,rnd,grey]  8
#
srp0    46
mirp[rp0,rnd,grey]  gap_170   31
mirp[min,rnd,grey]  hstem   1
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     15
mirp[rp0,rnd,grey]  vheight_shoot 28
ip      24
mirp[min,rnd,grey]  vstem_113   5
mdap[rnd]   24
alignrp     11
mirp[min,rnd,grey]  vstem 8
srp0    15
mdrp[rp0,rnd,grey]  21
f_deltap    21 18-8   21 19-8   21 23-8   21 24-8   21 25-8   21 26-8   21 28-8
mirp[min,rnd,grey]  headstem 39
mirp[rnd,grey]  headstem_plus_hole 33
IUP[y]
""",

    #mo_ma
    "uni0E21": """
f_deltap    62 10+8   62 11+8   62 18+8   62 22+8   62 27+8    62 28+8 
srp0        61
mirp[rp0,rnd,grey]  gap_334 14
ip      20
mirp[min,rnd,grey]  hstem 26
shp[rp2]    3
mdap[rnd]   20
f_deltap    20 10+4   20 11+4    20 12+4
alignrp     9
mirp[min,rnd,grey]  headstem 46
shp[rp2]    58
mirp[rnd,grey]  headstem_plus_hole 40
shp[rp2]    52
#
srp0    62
mirp[rp0,rnd,grey]  gap_170 34
mirp[min,rnd,grey]  hstem 32
srp1    26
ip      1
ip      29
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
alignrp     6
mirp[min,rnd,grey]  vstem 30
mirp[rp0,rnd,grey]  vheight 23
alignrp     34
mdrp[rp0,rnd,grey]  17
f_deltap    17 18+8   17 19+8   17 23+8   17 24+8   17 25+8   17 26+8   17 28+8
mirp[min,rnd,grey]  headstem 37
mirp[rnd,grey]  headstem_plus_hole 43
srp0    6
mdrp[rp0,rnd,grey]  12
ip      27
ip      3
mirp[min,rnd,grey]  headstem 55
mirp[rnd,grey]  headstem_plus_hole 49
IUP[y]
""",

    #yo_yak
    "uni0E22": """
f_deltap    52 9+8   52 10+8   52 27+8   52 28+8   52 30+8   50 38+8   50 39+8   50 44+8   
srp0        51
mirp[rp0,rnd,grey]  gap_152 3
ip  10
mirp[min,rnd,grey]  hstem 28
ip  7
mdap[rnd]   10
mdrp[rp0,rnd,grey]  16
ip  21
mirp[min,rnd,grey]  headstem 42
mirp[rnd,grey]  headstem_plus_hole 48
srp0    7
mdrp[grey]  24
#
srp0        52
mirp[rp0,rnd,grey]  gap_170 36
mirp[min,rnd,grey]  hstem 34
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
mirp[min,rnd,grey]  vstem 32
mirp[rp0,rnd,grey]  vheight 13
alignrp     36
mdrp[rp0,rnd,grey]  19
mirp[min,rnd,grey]  headstem 39
mirp[rnd,grey]  headstem_plus_hole 45
srp2    32
ip      24
mdrp[rnd,grey]  21
mdap[rnd]   24
mdrp[grey]  25
mdrp[grey]  7
IUP[y]
""",

    #ro_ruar
    "uni0E23": """
#srp0        50
#mirp[rp0,grey]  gap_84 10
#srp0    10
#mdrp[min,rnd,grey]  33
#
srp0        51
mirp[rp0,rnd,grey]  gap_190 34
ip      23
ip      22
mirp[min,rnd,grey]  hstem 8
mdrp[rp0,rnd,grey]  3
srp2    50
ip  10
mirp[min,rnd,grey]  headstem 47
mirp[rnd,grey]  headstem_plus_hole 41
srp0    10
mdrp[min,rnd,grey]  33
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]  0
mirp[rp0,rnd,grey]  vheight_shoot 13
alignrp     21
ip  10
mirp[min,rnd,grey]  vstem_113 30
mdrp[rp0,rnd,grey]  18
f_deltap    18 10+4   18 11+4   18 12+4   18 13+4   18 14+4   18 15+4   
mirp[min,rnd,grey]  vstem_113 25
srp0    0
mdrp[rp0,rnd,grey]  6
mirp[min,rnd,grey]  headstem 44
mirp[rnd,grey]  headstem_plus_hole 38
srp0    10
f_deltap    10 9-4   10 10-4   10 11-4   10 12-4   10 13-4   10 14-4 
mdrp[grey]  33
mdrp[grey]  9
srp0    33
mdrp[grey]  34
IUP[y]
""",

    #ro_ru
    "uni0E24": """
f_deltap    46 9+8   46 10+8   46 12+8   46 19+8   46 27+8
srp0                45
mirp[rp0,rnd,grey]  gap_170 23
ip  25
mirp[min,rnd,grey]  hstem 11
mdrp[rp0,rnd,grey]  17
f_deltap    17 9-4   17 12-4   17 16-8   17 19-8   17 26-8   17 33-8
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 42
srp0    25
mdrp[min,rnd,grey]  8
#
srp0                46
mirp[rp0,rnd,white] gap_170 31
mirp[min,rnd,grey]  hstem   1
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]           20
mirp[rnd,grey]      vheight_lu   1
mirp[rp0,rnd,grey]  vheight_shoot    28
ip  24
mirp[min,rnd,grey]  vstem_113  5
mdap[rnd]   24
alignrp     11
mirp[min,rnd,grey]  vstem   8
srp0        20
mdrp[rp0,rnd,grey]  14
f_deltap    14 18-8   14 19-8   14 23-8   14 24-8   14 25-8   14 26-8   14 28-8
mirp[min,rnd,grey]  headstem 39
mirp[rnd,grey]  headstem_plus_hole 33
IUP[y]
""",

    #lo_ling
    "uni0E25": """
f_deltap    56 9+8   56 10+8   56 12+8   56 19+8   56 27+8   56 29+8   
srp0    55
mirp[rp0,rnd,grey]  gap_129 20
mirp[min,rnd,grey]  hstem 8
ip  35
mdrp[rp0,rnd,grey]  14
f_deltap    14 12-4   14 16-8   14 19-8   14 26-8   
mirp[min,rnd,grey]  headstem 46
mirp[rnd,grey]  headstem_plus_hole 52
#
srp0    56 
mirp[rp0,rnd,white] gap_170    42
mirp[min,rnd,grey]  hstem   27
shp[rp2]    1
IUP[x]
SVTCA[y-axis]
mdap[rnd]   1
alignrp     17
mirp[rp0,rnd,grey]  vheight_shoot 39
mirp[min,rnd,grey]  vstem_113 31
srp1    1
ip      24
ip      27
mdap[rnd]   24
mirp[min,rnd,grey]  vstem_113 5
srp0    17
mdrp[rp0,rnd,grey]  11
f_deltap    11 18-8   11 19-8   11 23-8   11 24-8   11 25-8   11 26-8   11 28-8
mirp[min,rnd,grey]  headstem 49
mirp[rnd,grey]  headstem_plus_hole 43
IUP[y]
""",

    #lo_lu
    "uni0E26": """
f_deltap    46 10+8   46 18+8   46 28+8   46 29+8
srp0    45
mirp[rp0,rnd,grey]  gap_334 23
ip  18
ip  25
mirp[rp0,min,rnd,grey]  hstem 11
mdap[rnd]   18
f_deltap    18 10+4   18 11+4    18 12+4
mirp[min,rnd,grey]  headstem 42
mirp[rnd,grey]  headstem_plus_hole 36
srp0    25
mdrp[min,rnd,grey]  8
#
srp0    46
mirp[rp0,rnd,grey]  gap_170   31
mirp[min,rnd,grey]  hstem   1
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   15
mirp[rnd,grey]  vheight_lu 1
mirp[rp0,rnd,grey]  vheight_shoot 28
ip      24
mirp[min,rnd,grey]  vstem_113   5
mdap[rnd]   24
alignrp     11
mirp[min,rnd,grey]  vstem 8
srp0    15
mdrp[rp0,rnd,grey]  21
f_deltap    21 18-8   21 19-8   21 23-8   21 24-8   21 25-8   21 26-8   21 28-8
mirp[min,rnd,grey]  headstem 39
mirp[rnd,grey]  headstem_plus_hole 33
IUP[y]
""",

    #wo_wan
    "uni0E27": """
srp0    40
mirp[rp0,rnd,grey]  gap_170 23
mirp[min,rnd,grey]  hstem 8
mdrp[rp0,rnd,grey]  3
f_deltap    3 12+4   3 16+8   3 19+8   3 26+8   
srp1    39
ip  16
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 30
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
mirp[rp0,rnd,grey]  vheight_shoot 20
mirp[min,rnd,grey]  vstem_113   12
srp0    0
mdrp[rp0,rnd,grey]  6
f_deltap    6 18-8   6 19-8   6 23-8   6 24-8   6 25-8   6 26-8   6 28-8
mirp[min,rnd,grey]  headstem 33
mirp[rnd,grey]  headstem_plus_hole 27
IUP[y]
""",

    #so_sala
    "uni0E28": """
f_deltap    61 9+8    61 10+8   61 11+8   61 16-8   61 17-8   61 18+8    61 21+8   61 22+8   
srp0                60
mirp[rp0,rnd,white] gap_190 17
ip  20
mirp[min,rnd,grey]  hstem 15
ip  45
srp0    20
mdrp[min,rnd,grey]  43
#
srp0                61
mirp[rp0,rnd,white] gap_190 34
mirp[min,rnd,grey]  hstem 1
sloop   6
ip  37 5 26 31 28 29
#
srp1    15
ip      10
mdap[rnd]  10
f_deltap    10 11+4
mirp[min,rnd,grey]  headstem 51
mirp[rnd,grey]  headstem_plus_hole 57
f_deltap    57 20+8
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]           0
ALIGNRP             16
MIRP[rp0,rnd,grey]  vheight_shoot  23
mdrp[rnd,grey]      29
MIRP[rp0,min,rnd,grey]  vstem_113  40
srp1    0
ip  35
mdap[rnd]   35
f_deltap    35 16-8   35 20-8
srp2    23
sloop   6
ip      28 29 26 31 37 5 
MIRP[min,rnd,grey]  headstem  54
MIRP[rp0,rnd,grey]  headdia  13
f_deltap    13 13-8     13 14-8     13 15-8     13 16-8
MIRP[min,rnd,grey]  headstem  48
IUP[y]
""",

    #so_rusi
    "uni0E29": """
f_deltap    63 10+8    63 11+8   63 18+8   63 22+8   63 27+8   63 28+8   63 38+8   63 39+8
srp0    62
mirp[rp0,rnd,grey]  gap_334 3
ip      9
mdrp[grey]      1
mirp[min,rnd,grey]  hstem 48
shp[rp2]    15
mdap[rnd]   9
f_deltap    9 10+4   9 11+4   9 12+4
mirp[min,rnd,grey]  headstem 59
mirp[rnd,grey]  headstem_plus_hole 53
#
srp0    63
mirp[rp0,rnd,grey]  gap_190 33
alignrp     37
mirp[min,rnd,grey]  hstem 31
shp[rp2]    42
srp1    48
sloop   3
ip  26 21 22
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]  0
mirp[min,rnd,grey]  vstem 40
shp[rp2]    3
mirp[rp0,rnd,grey]  vheight 12
alignrp 33
sloop   8
ip      16 19 21 22 24 31 43 48
mdrp[rp0,rnd,grey]  6
f_deltap    6 18+8   6 19+8   6 23+8   6 24+8   6 25+8   6 26+8   6 28+8
mirp[min,rnd,grey]  headstem 50
mirp[rnd,grey]  headstem_plus_hole 56
IUP[y]
""",

    #so_sua
    "uni0E2A": """
f_deltap    70 9+8   70 10+8   70 12+8   70 19+8   70 27+8   70 29+8 
srp0    69
mirp[rp0,rnd,grey]  gap_129 20
mirp[min,rnd,grey]  hstem 8
ip  33
mdrp[rp0,rnd,grey]  14
f_deltap    14 12-4   14 16-8   14 19-8   14 26-8
mirp[min,rnd,grey]  headstem 60
mirp[rnd,grey]  headstem_plus_hole 66
#
srp0    70
mirp[rp0,rnd,white] gap_190    48
mirp[min,rnd,grey]  hstem   49
shp[rp2]    1
sloop   6
ip  26 52 40 42 43 45
IUP[x]
SVTCA[y-axis]
mdap[rnd]   1
alignrp     17
mirp[rp0,rnd,grey]  vheight_shoot 37
mirp[min,rnd,grey]  vstem_113 29
srp1    1
ip      24
ip      49
mdap[rnd]   24
srp2    37
sloop   5
ip  52 26 40 45 43
mirp[min,rnd,grey]  vstem_113 5
srp0    17
mdrp[rp0,rnd,grey]  11
f_deltap    11 18-8   11 19-8   11 23-8   11 24-8   11 25-8   11 26-8   11 28-8
mirp[min,rnd,grey]  headstem 63
mirp[rnd,grey]  headstem_plus_hole 57
IUP[y]
""",

    #ho_hib
    "uni0E2B": """
f_deltap    68 9+8   68 10+8   68 11+8   68 19+8    68 28+8
srp0        67
mirp[rp0,rnd,grey]  gap_334 10
ip  16
mirp[min,rnd,grey]  hstem 22
shp[rp2]    9
mdap[rnd]   16
f_deltap    16 10+4   16 11+4   16 12+4
mirp[min,rnd,grey]  headstem 52
mirp[rnd,grey]  headstem_plus_hole 46
#
srp0        68
mirp[rp0,rnd,white] gap_170 42
mirp[min,rnd,grey]  hstem 1
ip  36
srp1        22
ip  24
ip  8
mdap[rnd]   36
mdrp[min,rnd,grey]  58
mdrp[rp0,rnd,grey]  30
ip  39
ip  27
mdrp[min,rnd,grey]  64
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   0
alignrp     9
mirp[rp0,rnd,grey]  vheight 19
alignrp     33
ip  23
mdrp[rp0,rnd,grey]  13
f_deltap    13 18+8   13 19+8   13 23+8   13 24+8   13 25+8   13 26+8
sloop   3
ip  27 39 5
mirp[min,rnd,grey]  headstem 43
shp[rp2]    55
mirp[rnd,grey]  headstem_plus_hole 49
shp[rp2]    61
IUP[y]
""",

    #lo_jula
    "uni0E2C": """
f_deltap   61 9+8   61 10+8   61 11+8   61 18+8   61 22+8   61 28+8   61 29+8    61 34+8   61 40+8   61 41+8
srp0    60
mirp[rp0,rnd,grey]  gap_334  4
ip      10
mirp[min,rnd,grey]  hstem 16
shp[rp2]    3
mdap[rnd]   10
f_deltap    10 10+4   10 11+4    10 12+4
mirp[min,rnd,grey]  headstem 45
mirp[rnd,grey]  headstem_plus_hole 39
#
srp0    61
f_deltap    61 10+8
mirp[rp0,rnd,grey]  gap_190 35
ip  33
ip  32
mirp[min,rnd,grey]  hstem   20
shp[rp2]    1
srp1    16
sloop   3
ip      18 19 2
mdrp[rp0,rnd,grey]  24
mirp[min,rnd,grey]  headstem 57
mirp[rnd,grey]  headstem_plus_hole 51
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]   1
alignrp     3
mdrp[min,rnd,grey]  20
shp[rp2]    17
mirp[rp0,rnd,grey]  vheight 13
ip  18
ip  2
mdrp[rp0,rnd,grey]  7
f_deltap    7 18+8   7 19+8   7 23+8   7 24+8   7 25+8   7 26+8   7 28+8
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 42
srp0    13
mdrp[rp0,rnd,grey]  27
sloop   4
ip  30 32 33 35
mdrp[rp0,rnd,grey]  21
mirp[min,rnd,grey]  headstem 48
mirp[rnd,grey]  headstem_plus_hole 54
IUP[y]
""",

    #aw_ang
    "uni0E2D": """
f_deltap    52 9+8   52 10+8   52 11+8   52 12+8   52 18+8   
srp0    51
mirp[rp0,rnd,grey]  gap_102 3
mirp[min,rnd,grey]  hstem 15
ip  29
mdrp[rp0,rnd,grey]  10
mirp[min,rnd,grey]  headstem   42
mirp[rnd,grey]  headstem_plus_hole 48
#
srp0     52
mirp[rp0,rnd,white]  gap_170 36
mirp[min,rnd,grey]  hstem 21
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mirp[min,rnd,grey]  vstem   19
mirp[rp0,rnd,grey]  vheight_shoot  33
ip      29
ip      7
mirp[min,rnd,grey]  vstem_113   25
mdap[rnd]   7
f_deltap    7 9-4   7 10-4   
mdrp[rp0,rnd,grey]  13
f_deltap    13 18+8   13 19+8   13 23+8   13 24+8   13 25+8   13 26+8   
mirp[min,rnd,grey]  headstem    39
mirp[rnd,grey]  headstem_plus_hole 45
IUP[y]
""",

    #ho_nokhuk
    "uni0E2E": """
f_deltap    72 9+8   72 10+8   72 11+8   72 12+8   72 18+8
srp0    71
mirp[rp0,rnd,grey]  gap_129 3
mirp[min,rnd,grey]  hstem 15
ip  30
mdrp[rp0,rnd,grey]  10
mirp[min,rnd,grey]  headstem   62
mirp[rnd,grey]  headstem_plus_hole 68
#
srp0     72
mirp[rp0,rnd,white]  gap_190 44
mirp[min,rnd,grey]  hstem 21
sloop   5
ip  50 36 38 39 41
srp0    30
mdrp[min,rnd,grey]  56
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mirp[min,rnd,grey]  vstem   19
mirp[rp0,rnd,grey]  vheight_shoot  33
ip      7
mirp[min,rnd,grey]  vstem_113   53
mdap[rnd]   7
f_deltap    7 9-4   7 10-4
srp2    33
sloop   7
ip  39 36 41 50 24 47 27
mdrp[rp0,rnd,grey]  13
f_deltap    13 18+8   13 19+8   13 23+8   13 24+8   13 25+8   13 26+8
mirp[min,rnd,grey]  headstem    59
mirp[rnd,grey]  headstem_plus_hole 65
IUP[y]
""",

    #paiyannoi
    "uni0E2F": """
f_deltap    38 9+8   38 10+8   38 11+8   38 12+8
srp0    37
mirp[rp0,rnd,grey]  gap_102 14
mdrp[min,rnd,grey]  25
#
srp0    38
mirp[rp0,rnd,white]  gap_170 36
mirp[min,rnd,grey]  hstem 1
srp1    25
sloop   6
ip  19 20 31 32 7 8
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
mirp[rp0,rnd,grey]  vheight 35
ip  17
mdrp[min,rnd,grey]  4
mdap[rnd]   17
mdrp[min,rnd,grey]  22
mdrp[rp0,rnd,grey]  11
sloop   6
ip  19 20 31 32 7 8 
mdrp[min,rnd,grey]  28
IUP[y]
""",

    #sara_a
    "uni0E30": """
f_deltap    61 11+8   
srp0    60
mirp[rp0,rnd,white]  gap_129 3
alignrp 33
mirp[min,rnd,grey]  headstem 27
shp[rp2]    57
mirp[rp0,rnd,grey]  headdia 9
f_deltap    9 13+8    9 14+8   9 15+8   9 16+8
alignrp 39
mirp[min,rnd,grey]  headstem 21
shp[rp2]    51
mdrp[rnd,grey]  11
shp[rp2]    41
srp0    61
mirp[rp0,rnd,white] gap_170 15
alignrp 45
mdrp[min,rnd,grey]  14
shp[rp2]    44
IUP[x]
SVTCA[y-axis]
MDAP[rnd]  0
mdrp[min,rnd,grey]  11
mdrp[rp0,rnd,grey]  6
f_deltap    6 21-8
mirp[min,rnd,grey]  headstem 24
mirp[rnd,grey]  headstem_plus_hole 18
f_deltap    18 20+8
mdrp[rnd,grey]  15
srp0    0
mirp[rp0,rnd,grey]  vheight 36
mirp[min,rnd,grey]  headstem 54
mirp[rnd,grey]  headstem_plus_hole 48
f_deltap    48 20+8
mdrp[rnd,grey]  45
mdrp[rp0,rnd,grey]  30
f_deltap    30 21+8
mdrp[min,rnd,grey]  41
IUP[y]
""",

    #sara_maihanakat
    "uni0E31": """
mdap[rnd]   3
mirp[min,rnd,grey]  headstem 27
mirp[rp0,rnd,grey]  headdia 9
f_deltap    9 13+8   9 14+8   9 15+8   9 16+8
mirp[min,rnd,grey]  headstem 21
mdrp[grey]  11
srp0    3
mdrp[rp0,rnd,grey]  15
mdrp[min,rnd,grey]  14
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8  0 11+8  0 12+8  0 14+8  0 15+8  0 16+8  
mdrp[min,rnd,grey]  18
mdrp[rp0,rnd,grey]  6
f_deltap    6 12-4   6 16-8   6 17-8
mirp[min,rnd,grey]  headstem 24
IUP[y]
""",

    #sara_aa
    "uni0E32": """
srp0    18
mirp[rp0,rnd,white]  gap_61 9
srp0    19
mirp[rp0,rnd,white] gap_170 16
mirp[min,rnd,grey]  hstem 1
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   1
mirp[rp0,rnd,grey]  vheight_shoot 13
mirp[min,rnd,grey]  vstem_113   5
IUP[y]
""",

    #sara_am
    #uni0E33: use sara_aa with nikahit
    
    #sara_i
    "uni0E34": """
mdap[rnd]   0
mdrp[min,rnd,grey]   8
mdrp[rp0,rnd,grey]  4
mdrp[min,rnd,grey]   12
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8  0 11+8  0 12+8  0 13+8  0 14+8  0 15+8  0 16+8  
mdrp[min,rnd,grey]  6
sloop   4
ip  10 14 2 4
IUP[y]
""",

    #sara_ii
    "uni0E35": """
mdap[rnd]   0
mdrp[min,rnd,grey]   13
mdrp[min,rnd,grey]   9
mdrp[rp0,rnd,grey]  4
mdrp[min,rnd,grey]   17
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8  0 11+8  0 12+8  0 13+8  0 14+8  0 15+8  0 16+8
mdrp[rp0,rnd,grey]  6
sloop   4
ip  15 19 2 4
mdrp[min,rnd,grey]  9
IUP[y]
""",

    #sara_ue
    "uni0E36": """
mdap[rnd]   0
mdrp[min,rnd,grey]   21
mdrp[rp0,rnd,grey]  4
ip  8
mdrp[min,rnd,grey]   25
mdap[rnd]   8
mirp[min,rnd,grey]  headstem 38
mirp[rp0,rnd,grey]  headdia 15
f_deltap    15 13+8   15 14+8   15 15+8  15 16+8
mirp[min,rnd,grey]  headstem 32
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8  0 11+8  0 12+8  0 13+8  0 14+8  0 15+8  0 16+8
mdrp[rp0,rnd,grey]  6
sloop   4
ip  23 27 2 4
mdrp[rp0,rnd,grey]  12
mirp[min,rnd,grey]  headstem 35
mirp[rp0,rnd,grey]  headdia 19
f_deltap    19 13-8   19 14-8   19 15-8  19 16-8
mirp[min,rnd,grey]  headstem 29
IUP[y]
""",

    #sara_uee
    "uni0E37": """
mdap[rnd]   0
mdrp[min,rnd,grey]   16
mdrp[min,rnd,grey]   7
ip  12
ip  8
mdrp[rp0,rnd,grey]  4
mdrp[min,rnd,grey]   25
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8  0 11+8  0 12+8  0 13+8  0 14+8  0 15+8  0 16+8
mdrp[rp0,rnd,grey]  6
sloop   4
ip  18 22 2 4
mdrp[min,rnd,grey]  8
shp[rp2]    13
IUP[y]
""",

    #sara_u
    "uni0E38": """
mdap[rnd]   0
mdrp[min,rnd,grey]  2
mdrp[rp0,rnd,grey]  5
mirp[min,rnd,grey]  headstem_small 21
mirp[rnd,grey]  headstem_small_plus_hole 15
IUP[x]
SVTCA[y-axis]
mdap[rnd]   8
f_deltap    8 9-8   8 10-8  8 11-8   8 12-8   8 13-8   8 14-8   8 15-8
mirp[min,rnd,grey]  headstem_small 18
mirp[rp0,rnd,grey]  headdia_small 2
f_deltap    2 13-8  2 14-8  2 15-8  2 16-8
mirp[min,rnd,grey]  headstem_small 12
mdrp[min,rnd,grey]  0
IUP[y]
""",

    #sara_uu
    "uni0E39": """
mdap[rnd]   19
mdrp[min,rnd,grey]  17
mdrp[rp0,rnd,grey]  12
f_deltap    12 13-8  12 14-8  
mdrp[min,rnd,grey]  2
mirp[min,rnd,grey]  headstem_small 25
mirp[rp0,rnd,grey]  headdia_small 6
f_deltap    6 13-8  6 14-8   6 15-8   6 16-8
mirp[min,rnd,grey]  headstem_small 31
IUP[x]
SVTCA[y-axis]
mdap[rnd]   9
f_deltap    9 9-8   9 10-8  9 11-8   9 12-8   9 13-8   9 14-8   9 15-8
alignrp     19
mirp[min,rnd,grey]  headstem_small 28
mirp[rp0,rnd,grey]  headdia_small 3
f_deltap    3 13-8  3 14-8  3 15-8  3 16-8
mirp[min,rnd,grey]  headstem_small 22
mdrp[rp0,rnd,grey]  0
mdrp[min,rnd,grey]  15
IUP[y]
""",

    #pinthu
    "uni0E3A": """
mdap[rnd]   9
mirp[min,rnd,grey]  headdia_small 3
IUP[x]
SVTCA[y-axis]
mdap[rnd]   6
f_deltap    6 9-8   6 10-8  6 11-8   6 12-8   6 13-8   6 14-8   6 15-8
mirp[min,rnd,grey]  headdia_small 0
IUP[y]
""",

    #thai_baht
    "uni0E3F": """
f_deltap    48 9+8   48 10+8   48 12+8   48 13+8   48 17+8
srp0    47
mdrp[rp0,rnd,grey]  5
ip  4
ip  7
mdrp[min,rnd,grey]  38
shp[rp2]    27
#
srp0    48
mdrp[rp0,rnd,grey]  21
mdrp[min,rnd,grey]  32
mdrp[rp0,rnd,grey]  15
mdrp[min,rnd,grey]  43
ip  18
srp1    38
ip  36
mdap[rnd]   36
sloop   3
alignrp 9 25 1
mdrp[min,rnd,grey]  46
sloop   3
shp[rp2]    11 35 24
IUP[x]
SVTCA[y-axis]
mdap[rnd]   2
mdrp[min,rnd,grey]  25
shp[rp2]    29
shp[rp2]    5
mdrp[min,rnd,grey]  1
mdrp[rp0,rnd,grey]  9
alignrp     12
ip  36
mdrp[min,rnd,grey]  10
mdrp[min,rnd,grey]  37
shp[rp2]    6
shp[rp2]    46
mdap[rnd]   36
alignrp     40
mdrp[min,rnd,grey]  26
ip  18
shp[rp2]    35
IUP[y]
""",

    #sara_e
    "uni0E40": """
srp0    27
mirp[rp0,rnd,white]  gap_334 5
f_deltap    5 15-8
ip  11
mirp[min,rnd,grey]  hstem 3
mdap[rnd]   11
f_deltap    11 10-4   11 11-4   11 12-4   
mirp[min,rnd,grey]  headstem 17
mirp[rnd,grey]  headstem_plus_hole 23
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
mirp[rnd,grey]  vheight 4
mdrp[rp0,rnd,grey]  8
f_deltap    8 18-8    8 19-8   8 23-8   8 24-8   8 25-8   8 26-8
mirp[min,rnd,grey]  headstem 20
mirp[rnd,grey]  headstem_plus_hole 14
IUP[y]
""",

    #sara_ae
    #use sara_a reference: uni0E40

    #sara_o
    "uni0E42": """
srp0    42
mirp[rp0,rnd,grey]  gap_61 5
mdrp[min,rnd,grey]  20
#
srp0    43
mirp[rp0,rnd,grey]  gap_334 21
f_deltap    21 15-8
ip  27
ip  13
mirp[min,rnd,grey]  hstem 3
mdap[rnd]   27
f_deltap    27 10-4   27 11-4   27 12-4
mirp[min,rnd,grey]  headstem 33
mirp[rnd,grey]  headstem_plus_hole 39
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[rp0,rnd,grey]  24
f_deltap    24 18-8    24 19-8   24 23-8   24 24-8   24 25-8   24 26-8
mirp[min,rnd,grey]  headstem 36
mirp[rnd,grey]  headstem_plus_hole 30
mdap[rnd]   7
mdrp[rnd,grey]  5
mdrp[min,rnd,grey]  18
ip  12
mdrp[rp0,rnd,grey]  10
mdrp[min,rnd,grey]  15
srp1    0
ip  4
ip  21
IUP[y]
""",

    #sara_ai_maimoun
    "uni0E43": """
srp0    60
mirp[rp0,rnd,grey]  gap_61 33
mdrp[min,rnd,grey]  10
#
srp0    61
mirp[rp0,rnd,grey]  gap_334 39
f_deltap    39 15-8
ip  45
mirp[min,rnd,grey]  hstem 3
srp1    10
sloop   4
ip 22 23 16 27
mdap[rnd]   45
f_deltap    45 10-4   45 11-4   45 12-4
mirp[min,rnd,grey]  headstem 51
mirp[rnd,grey]  headstem_plus_hole 57
IUP[x]
SVTCA[y-axis]
#
MDAP[rnd]   0
mdrp[rp0,rnd,grey]  42
f_deltap    42 18-8    42 19-8   42 23-8   42 24-8   42 25-8   42 26-8
mirp[min,rnd,grey]  headstem 54
mirp[rnd,grey]  headstem_plus_hole 48
srp0    0
mdrp[rp0,rnd,grey]  36
ip  30
mdrp[min,rnd,grey]  7
mdap[rnd]  30
mdrp[min,rnd,grey]  13
srp1    7
ip  22
ip  21
IUP[y]
""",

    #sara_ai_malai
    "uni0E44": """
srp0    19
mirp[rp0,rnd,grey]  gap_84 15
mdrp[min,rnd,grey]  23
#
srp0    57
mirp[rp0,rnd,grey]  gap_334 35
f_deltap    35 15-8
ip  41
mirp[min,rnd,grey]  hstem 3
srp1    23
ip  29
ip  8
mdap[rnd]   41
f_deltap    41 10-4   41 11-4   41 12-4
mirp[min,rnd,grey]  headstem 47
mirp[rnd,grey]  headstem_plus_hole 53
IUP[x]
SVTCA[y-axis]
#
MDAP[rnd]   0
mdrp[rp0,rnd,grey]  38
f_deltap    38 18-8    38 19-8   38 23-8   38 24-8   38 25-8   38 26-8
mirp[min,rnd,grey]  headstem 50
mirp[rnd,grey]  headstem_plus_hole 44
srp0    0
mdrp[rp0,rnd,grey]  32
ip  12
mdrp[min,rnd,grey]  6
mdrp[min,rnd,grey]  20
mdap[rnd]  12
mdrp[min,rnd,grey]  26
IUP[y]
""",

    #lakkhangyao
    "uni0E45": """
srp0    18
mirp[rp0,rnd,grey]  gap_152 9
srp0    19
mirp[rp0,rnd,white] gap_246 16
mirp[min,rnd,grey]  hstem 1
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   18
mirp[rp0,rnd,grey]  vheight_lu 1
srp0    18
mirp[rp0,rnd,grey]  vheight_shoot 13
mirp[min,rnd,grey]  vstem_113   5
IUP[y]
""",

    #maiyamok
    "uni0E46": """
srp0    40
mirp[rp0,rnd,grey]  gap_152 18
mdrp[min,rnd,grey]  9
mdrp[rp0,rnd,grey]  12
mirp[min,rnd,grey]  headstem 31
mirp[rnd,grey]  headstem_plus_hole 37
#
srp0    41
mirp[rp0,rnd,grey]  gap_246 26
mirp[min,rnd,grey]  hstem 1
srp1    9
sloop   6
ip  21 22 23 5 6 7
IUP[x]
#
SVTCA[y-axis]
srp0    40
mirp[rnd,grey]  vheight_lu  1
mirp[rp0,rnd,grey]  vheight 21
mdrp[min,rnd,grey]  7
mdrp[rp0,rnd,grey]  22
mdrp[rp0,min,rnd,grey]  6
mdrp[rp0,rnd,white] 9
mirp[min,rnd,grey] headstem 35
mirp[rp0,rnd,grey] headdia 15
mirp[min,rnd,grey] headstem 28
IUP[y]
""",

    #maitaikhu
    "uni0E47": """
srp0    64
mirp[rp0,rnd,grey]  gap_246 49
#f_deltap    11 10-4   11 11-4   11 12-4
ip  24
mirp[min,rnd,grey]  headstem_small 55
mirp[rp0,rnd,grey]  headdia_small 43
mirp[min,rnd,grey]  headstem_small 61
mdrp[rnd,grey]  41
srp0    49
mdrp[rp0,rnd,grey]  10
ip  34
ip  7
mdrp[min,rnd,grey]  31  
mdap[rnd]   24
mdrp[min,rnd,grey]  17
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
alignrp     7
mdrp[min,rnd,grey]  41
mirp[min,rnd,grey]  headstem_small 52
mirp[rp0,rnd,grey]  headdia_small 46
sloop   3
ip      38 34 3
mirp[min,rnd,grey]  headstem_small 58
mdrp[rp0,rnd,white] 27
mdrp[min,rnd,grey]  14
mdrp[rnd,grey]  21
IUP[y]
""",

    #maiek
    "uni0E48": """
mdap[rnd]   6
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8   0 17+8
IUP[y]
""",

    #maiek
    "uni0E48.low": """
mdap[rnd]   6
mdrp[min,rnd,grey]  5
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
mdrp[min,rnd,grey]  6
IUP[y]
""",

    #maitho
    "uni0E49": """
mdap[rnd]   13
mdrp[grey]  29
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8   0 17+8
mdrp[grey]  26
IUP[y]
""",

    #maitho
    "uni0E49.low": """
mdap[rnd]   23
mdrp[min,rnd,grey]  19
mdrp[rp0,rnd,grey]  13
mirp[min,rnd,grey]  headstem_small 29
mirp[rp0,rnd,grey]  headdia_small 7
mirp[min,rnd,grey]  headstem_small 35
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
mdrp[min,rnd,grey]  1
mdrp[rp0,rnd,grey]  3
mirp[min,rnd,grey]  headstem_small 26
mirp[rp0,rnd,grey]  headdia_small 10
mirp[min,rnd,grey]  headstem_small 32
mdrp[rnd,grey]  21
IUP[y]
""",

    #maitri
    "uni0E4A": """
mdap[rnd]   34
mdrp[grey]  60
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8   0 17+8
alignrp     23
mdrp[grey]  51
IUP[y]
""",

    #maitri
    "uni0E4A.low": """
mdap[rnd]   48
mdrp[rp0,rnd,grey]  34
mdrp[rp0,rnd,grey]  20
mirp[min,rnd,grey]  headstem_small 54
mirp[rp0,rnd,grey]  headdia_small 14
mirp[min,rnd,grey]  headstem_small 60
mdrp[min,rnd,grey]  26
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
alignrp     23
mdrp[rp0,rnd,grey]  31
alignrp     29
mdrp[min,rnd,grey]  7
shp[rp2]    9
srp0    23
mirp[min,rnd,grey]  headstem_small 51
mirp[rp0,rnd,grey]  headdia_small 17
mirp[min,rnd,grey]  headstem_small 57
IUP[y]
""",

    #maichattawa
    "uni0E4B": """
mdap[rnd]   7
IUP[x]
SVTCA[y-axis]
mdap[rnd]   10
f_deltap    10 9+8   10 11+8   10 12+8   10 13+8   10 14+8   10 15+8   10 16+8
f_deltap    10 9+8   10 11+8   10 12+8   10 13+8   10 14+8   10 15+8   10 16+8   10 17+8
IUP[y]
""",

    #maichattawa
    "uni0E4B.low": """
mdap[rnd]   7
IUP[x]
SVTCA[y-axis]
mdap[rnd]   10
f_deltap    10 9+8   10 11+8   10 12+8   10 13+8   10 14+8   10 15+8   10 16+8
IUP[y]
""",

    #thanthakhat
    "uni0E4C": """
mdap[rnd]   15
mdrp[grey]  21
IUP[x]
SVTCA[y-axis]
mdap[rnd]   13
f_deltap    13 9+8   13 11+8   13 12+8   13 13+8   13 14+8   13 15+8   13 16+8
f_deltap    13 9+8   13 11+8   13 12+8   13 13+8   13 14+8   13 15+8   13 16+8   13 17+8
mdrp[grey]  18
IUP[y]
""",

    #thanthakhat
    "uni0E4C.low": """
mdap[rnd]   11
mdrp[min,rnd,grey]  9
mdrp[rp0,rnd,grey]  15
mirp[min,rnd,grey]  headstem_small 21
mirp[rp0,rnd,grey]  headdia_small 3
mirp[min,rnd,grey]  headstem_small 27
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
mirp[min,rnd,grey]  headstem_small 18
mirp[rp0,rnd,grey]  headdia_small 6
mirp[min,rnd,grey]  headstem_small 24
mdrp[min,rnd,grey]  9
IUP[y]
""",

    #nikhahit
    "uni0E4D": """
mdap[rnd]   9
mirp[min,rnd,grey]  headstem 15
mirp[rp0,rnd,grey]  headdia 3
mirp[min,rnd,grey]  headstem 21
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
mirp[min,rnd,grey]  headstem 12
mirp[rp0,rnd,grey]  headdia 6
mirp[min,rnd,grey]  headstem 18
IUP[y]
""",

    #nikhahit
    "uni0E4D.high": """
MDAP[rnd]   0
mdrp[rp0,rnd,grey]  9
mdrp[min,rnd,grey]  15
mdrp[rp0,rnd,grey]  3
mdrp[min,rnd,grey]  21
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  12
mdrp[rp0,rnd,grey]  6
mdrp[min,rnd,grey]  18
IUP[y]
""",

    #yamakkan
    "uni0E4E": """
mdap[rnd]   16
mdrp[min,rnd,grey]  21
mdrp[rp0,rnd,grey]  26
mdrp[min,rnd,grey]  10
mdrp[rp0,rnd,grey]  45
mdrp[min,rnd,grey]  3
IUP[x]
SVTCA[y-axis]
mdap[rnd]   0
f_deltap    0 9+8   0 11+8   0 12+8   0 13+8   0 14+8   0 15+8   0 16+8
mdrp[min,rnd,grey]  48
mdrp[rp0,rnd,grey]  42
mdrp[min,rnd,grey]  6
mdrp[rp0,rnd,grey]  23
mdrp[min,rnd,grey]  13
IUP[y]
""",

    #fongman
    "uni0E4F": """
#f_deltap    53 9-8   53 10+8   53 11+8   53 13+8   53 18+8   53 20-8   53 21-8   53 22-8   
SRP0    52
mirp[rp0,rnd,grey]  gap_152 4
mirp[min,rnd,grey]  headstem 25
mdrp[rp0,rnd,grey]  31
mirp[min,rnd,grey]  headstem 49
#
#srp0    53
srp0    4
#mirp[rp0,rnd,grey]  gap_152 12
mdrp[rp0,rnd,grey]  12
mirp[min,rnd,grey]  headstem 19
mdrp[rp0,rnd,grey]  37
mirp[min,rnd,grey]  headstem 43
srp0    12
mirp[rnd,grey]  gap_152 53
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   52
mirp[rp0,rnd,grey]  vheight_lo  0
mirp[min,rnd,grey]  headstem 16
mdrp[rp0,rnd,grey]  28
mirp[min,rnd,grey]  headstem 40
srp0    0
mdrp[rp0,rnd,grey]  8
mirp[min,rnd,grey]  headstem 22
mdrp[rp0,rnd,grey]  34
mirp[min,rnd,grey]  headstem 46
IUP[y]
""",

    #thaidigit_zero
    "uni0E50": """
f_deltap    33 11+8   33 13+8   
SRP0    32
mirp[rp0,rnd,grey]  gap_152 4
mdrp[min,rnd,grey]  28
#
srp0    33
mirp[rp0,rnd,grey]  gap_152 12
mdrp[min,rnd,grey]  20
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  16
mdrp[rp0,rnd,grey]  8
mdrp[min,rnd,grey]  24
IUP[y]
""",

    #thaidigit_one
    "uni0E51": """
f_deltap    51 10+8   51 12+8   51 14+8   
srp0    50
mirp[rp0,rnd,grey]  gap_152 3
mdrp[min,rnd,grey]  30
#
srp0    51
mirp[rp0,rnd,grey]  gap_152 9
mdrp[min,rnd,grey]  24
#
srp1    30
ip  47
mdap[rnd]   47
f_deltap    47 18-8   47 19-8
mdrp[min,rnd,grey]  41
ip  36
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  15
mdrp[min,rnd,grey]  33
mdrp[rp0,rnd,grey]  6
mdrp[min,rnd,grey]  27
srp1    33
ip  38
mdap[rnd]   38
f_deltap    38 25+8
mdrp[min,rnd,grey]  44
IUP[y]
""",

    #thaidigit_two
    "uni0E52": """
f_deltap    85 9+8   85 10+8  85 11+8    85 12+8    85 13+8
SRP0    84
mirp[rp0,rnd,grey]  gap_170 4
ip  7
mdrp[min,rnd,grey]  12
#
srp0    85
mirp[rp0,rnd,grey]  gap_152 81
mdrp[min,rnd,grey]  19
#
srp1    12
sloop   3
ip      69 57 43
mdap[rnd]   69
mdrp[min,rnd,grey]  49
mdap[rnd]   57
mdrp[min,rnd,grey]  63
mdap[rnd]   43
mdrp[min,rnd,grey]  28
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  16
mdrp[rp0,rnd,grey]  72
alignrp 78
mdrp[rnd,grey]  9
mdrp[min,rnd,grey]  46
shp[rp2]    22
mdrp[rp0,rnd,grey]  66
f_deltap    66 12+8   66 13+8   66 15+8   66 16+8   66 18+8   66 19+8   66 21+8
alignrp     34
mdrp[min,rnd,grey]  60
IUP[y]
""",

    #thaidigit_three
    "uni0E53": """
f_deltap    75 10+8   75 11+8  
SRP0    74
mirp[rp0,rnd,grey]  gap_152 3
mdrp[min,rnd,grey]  57
#
srp0    75
mirp[rp0,rnd,grey]  gap_152 13
mdrp[min,rnd,grey]  28
#
srp1    57
ip  71
ip  51
mdap[rnd]   71
f_deltap    71 10-8   71 13-8   71 14-8   71 20-8
mdrp[min,rnd,grey]  65
mdap[rnd]   51
f_deltap    51 13-8   51 14-8   51 22+8
mdrp[min,rnd,grey]  36
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   0
alignrp     19
alignrp     42
mdrp[min,rnd,grey]  68
mdrp[rp0,rnd,grey]  6
alignrp 10
mdrp[min,rnd,grey]  54
shp[rp2]    31
IUP[y]
""",

    #thaidigit_four
    "uni0E54": """
f_deltap    61 10+8   61 11+8   
srp0    60
mirp[rp0,rnd,grey]  gap_152 9
mdrp[min,rnd,grey]  30
#
srp0    61
mirp[rp0,rnd,grey]  gap_102 23
mdrp[min,rnd,grey]  16
srp1    30
sloop   3
ip  38 50 57
mdap[rnd]   38
mdrp[min,rnd,grey]  54
mdap[rnd]   50
mdrp[min,rnd,grey]  44
mdap[rnd]   57
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
alignrp     6
mdrp[min,rnd,grey]  57
srp0    6
mdrp[min,rnd,grey]  33
mdrp[rp0,rnd,grey]  18
ip  27
mdap[rnd]   27
mdrp[min,rnd,grey]  12
srp2    33
ip  41
mdap[rnd]   41
mdrp[min,rnd,grey]  47
IUP[y]
""",

    #thaidigit_five
    "uni0E55": """
f_deltap    88 10+8   88 11+8
srp0    87
mirp[rp0,rnd,grey]  gap_152 9
mdrp[min,rnd,grey]  45
#
srp0    88
mirp[rp0,rnd,grey]  gap_102 33
mdrp[min,rnd,grey]  26
srp1    45
sloop   4
ip  53 65 72 21
mdap[rnd]   53
mdrp[min,rnd,grey]  69
mdap[rnd]   65
mdrp[min,rnd,grey]  59
mdap[rnd]   72
mdap[rnd]   21
f_deltap    21 11-8   21 12-8   21 13-8   
mirp[min,rnd,grey]  headstem 78
mirp[rp0,rnd,grey]  headdia 15
f_deltap    15 14-8   15 15-8   15 16-8   
mirp[min,rnd,grey]  headstem 84
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
alignrp     6
mdrp[min,rnd,grey]  72
srp0    6
mdrp[min,rnd,grey]  48
mdrp[rp0,rnd,grey]  28
ip  39
mdap[rnd]   39
srp2    48
ip  56
mdrp[min,rnd,grey]  75
mdrp[rp0,rnd,grey]  18
mirp[min,rnd,grey]  headstem 81
mdap[rnd]   56
mdrp[min,rnd,grey]  62
IUP[y]
""",

    #thaidigit_six
    "uni0E56": """
f_deltap    66 17+8   66 24+8   
SRP0    65
mirp[rp0,rnd,grey]  gap_41  44
mdrp[rp0,rnd,grey]  32
mdrp[min,rnd,grey]  56
mdrp[rp0,rnd,grey]  3
mdrp[min,rnd,grey]  9
#
srp0    66
mirp[rp0,rnd,grey]  gap_152 62
mdrp[min,rnd,grey]  20
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  17
mdrp[rp0,rnd,grey]  59
ip  6
ip  29
mdrp[min,rnd,grey]  47
mdrp[min,rnd,grey]  23
mdap[rnd]   29
mdap[rnd]   6
mdrp[min,rnd,grey]  12
IUP[y]
""",

    #thaidigit_seven
    "uni0E57": """
f_deltap    92 9+8   92 10+8   92 11+8   92 12+8   92 13+8   
SRP0    91
mirp[rp0,rnd,grey]  gap_152 54
mdrp[min,rnd,grey]  37
#
srp0    92
mirp[rp0,rnd,grey]  gap_152 85
mdrp[min,rnd,grey]  72
mdrp[rp0,rnd,grey]  66
f_deltap    66 20-8
mdrp[min,rnd,grey]  9
srp1    37
ip  17
ip  48
mdap[rnd]   17
mdrp[min,rnd,grey]  31
mdap[rnd]   48
mdrp[min,rnd,grey]  42
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
alignrp     51
mdrp[min,rnd,grey]  69
srp0    51
mdrp[min,rnd,grey]  40
mdrp[min,rnd,grey]  45
mdrp[rp0,rnd,grey]  57
alignrp 63
mdrp[rnd,grey]  82
mdrp[min,rnd,grey]  34
shp[rp2]    12
srp1    45
ip      23
IUP[y]
""",

    #thaidigit_eight
    "uni0E58": """
f_deltap    73 10+8   73 11+8   73 12+8   73 14+8   
SRP0    72
mirp[rp0,rnd,grey]  gap_152 13
mdrp[min,rnd,grey]  42
mdrp[rp0,rnd,grey]  10
mdrp[min,rnd,grey]  47
#
srp0    73
mirp[rp0,rnd,grey]  gap_102 31
srp2    10
ip  69
mdrp[min,rnd,grey]  24
mdap[rnd]   69
mdrp[min,rnd,grey]  63  
IUP[x]
#
SVTCA[y-axis]
mdap[rnd]    0
alignrp 10
mdrp[min,rnd,grey]  55
mdrp[rp0,rnd,grey]  66
mdrp[min,rnd,grey]  60
srp0    10
mdrp[rp0,rnd,grey]  50
mdrp[min,rnd,grey]  5
mdrp[min,rnd,grey]  45
srp0    16
mdrp[min,rnd,grey]  39
mdrp[rnd,grey]      28
mdrp[rp0,rnd,grey]  21
mdrp[min,rnd,grey]  34
IUP[y]
""",

    #thaidigit_nine
    "uni0E59": """
f_deltap    75 10+8   75 12+8   75 14+8   75 16+8   
SRP0    74
mirp[rp0,rnd,grey]  gap_152 3
mdrp[min,rnd,grey]  64
mdrp[rp0,rnd,grey]  9
mdrp[min,rnd,grey]  38
#
srp0    75
mirp[rp0,rnd,grey]  gap_102 27
mdrp[min,rnd,grey]  20
srp2    54
ip  43
ip  71
mdap[rnd]   43
mdap[rnd]   71
mdrp[min,rnd,grey]  65
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   0
mdrp[min,rnd,grey]  57
mdrp[rp0,rnd,grey]  12
mdrp[rnd,grey]  24
mdrp[min,rnd,grey]  35
srp1    57
ip  41
ip  43
mdap[rnd]   41
mdrp[min,rnd,grey]  46
srp1    57
ip      68
mdap[rnd]   68
f_deltap    68 12-8   68 13-8   
mdrp[min,rnd,grey]  62
IUP[y]
""",

#    #angkhankhu
    "uni0E5A": """
f_deltap    49 9+8   49 10+8   49 11+8   49 12+8   49 13+8   
SRP0    48
mirp[rp0,rnd,grey]  gap_102 21
mdrp[min,rnd,grey]  32
#
srp0    49
mirp[rp0,rnd,grey]  gap_246 47
mirp[min,rnd,grey]  hstem 1
mdrp[rp0,rnd,grey]  43
alignrp 6
mirp[min,rnd,grey]  hstem 8
srp1 32
sloop   3
ip  26 27 39
mdap[rnd]   39
mdrp[min,rnd,grey]  14
IUP[x]
#
SVTCA[y-axis]
MDAP[rnd]   1
alignrp     8
mdrp[rp0,rnd,grey]  46
alignrp     42
mdrp[min,rnd,grey]  4
shp[rp2]    11
mdrp[rp0,rnd,grey]  24
mdrp[min,rnd,grey]  29
mdrp[rp0,rnd,grey]  18
mdrp[min,rnd,grey]  35
IUP[y]
""",

#    #khomut
    "uni0E5B": """
SRP0    70
mirp[rp0,min,rnd,grey]  headhole    3
mirp[rp0,min,rnd,grey]  hstem   26
mdrp[rp0,min,rnd,grey]  15
mirp[min,rnd,grey]  headstem   67
mdrp[rp0,min,rnd,grey]  9
mdrp[min,rnd,grey]  61
mdrp[min,rnd,grey]  20
mdrp[rp0,min,rnd,grey]  32
mdrp[min,rnd,grey]  33
mdrp[rp0,min,rnd,grey]  55
mdrp[min,rnd,grey]  54
mdrp[rp0,min,rnd,grey]  34
mdrp[rp0,min,rnd,grey]  37
mdrp[min,rnd,grey]  38
mdrp[rp0,min,rnd,grey]  52
mdrp[min,rnd,grey]  51
mdrp[rp0,min,rnd,grey]  39
mdrp[rp0,min,rnd,grey]  42
mdrp[min,rnd,grey]  43
mdrp[rp0,min,rnd,grey]  49
mdrp[rp0,min,rnd,grey]  46
mdrp[min,rnd,grey]  71
IUP[x]
SVTCA[y-axis]
MDAP[rnd]   70
mirp[rp0,rnd,grey]  vheight_lo  0
mirp[rp0,min,rnd,grey]  vstem_113 29
mdrp[rp0,min,rnd,grey]  12
mirp[min,rnd,grey]  headstem 58
mirp[rp0,rnd,grey]  headdia 18
mdrp[min,rnd,grey]  20
mirp[min,rnd,grey]  headstem 64
mdrp[rp0,min,rnd,grey]  23
mirp[min,rnd,grey]  vstem_113 6
srp0    0
mdrp[rp0,min,rnd,grey]  55
alignrp     52
alignrp     49
alignrp     45
mdrp[min,rnd,grey]  54
shp[rp2]    51
mdrp[rp0,min,rnd,grey]  32
alignrp 37
alignrp 42
mdrp[rp0,min,rnd,grey]  33
alignrp 38
alignrp 43
srp0    45
mdrp[min,rnd,grey]  46
IUP[y]
""",


#    #CHAR_NAME
#    "uni0EXX": """
#SRP0    0
#
#IUP[x]
#SVTCA[y-axis]
#MDAP[rnd]   0
#
#IUP[y]
#""",


}

if __name__=="__main__":
    if sys.argv[1] == "--all":
        #$0 --all = ENCODE ALL CHARS
        sfd_file = os.path.basename(sys.argv[0]).split('.',1)[0] + '.sfd'
        print "Encoding all character in %s" % (sfd_file)
        dfont.inst_encode_all( sfd_file, pseudo_code_dict, cvt_dict )
    else:
        #$0 uni0E01 > x.txt = PRINT INSTRUCTION CODE OF uni0E01 TO x.txt
        print '\n'.join(dfont.inst_encode( pseudo_code_dict[sys.argv[1]], cvt_dict ))
